///////////////////////////////////////////////////////////////////////////////
//                                                                            /
// IAR ANSI C/C++ Compiler V5.40.0.51500/W32 for ARM    07/Sep/2009  17:30:49 /
// Copyright (C) 1999-2009 IAR Systems AB.                                    /
//                                                                            /
//    Cpu mode     =  thumb                                                   /
//    Endian       =  little                                                  /
//    Source file  =  C:\My_App\Project\Template\Retarget.c                   /
//    Command line =  C:\My_App\Project\Template\Retarget.c -D                /
//                    USE_STDPERIPH_DRIVER -D STM32F10X_HD -D                 /
//                    USE_STM3210E_EVAL -lCN C:\My_App\Project\Template\EWARM /
//                    v5\STM3210E-EVAL\List\ -lB                              /
//                    C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\List\  /
//                    -o C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\Obj /
//                    \ --debug --endian=little --cpu=Cortex-M3 -e            /
//                    --fpu=None --dlib_config "C:\Program Files\IAR          /
//                    Systems\Embedded Workbench                              /
//                    5.4\arm\INC\DLib_Config_Full.h" -I                      /
//                    C:\My_App\Project\Template\EWARMv5\..\ -I               /
//                    C:\My_App\Project\Template\EWARMv5\..\..\..\Libraries\C /
//                    MSIS\Core\CM3\ -I C:\My_App\Project\Template\EWARMv5\.. /
//                    \..\..\Libraries\STM32F10x_StdPeriph_Driver\inc\ -I     /
//                    "C:\Program Files\IAR Systems\Embedded Workbench        /
//                    5.4\arm\INC\" -Ohz                                      /
//    List file    =  C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\List\R /
//                    etarget.s                                               /
//                                                                            /
//                                                                            /
///////////////////////////////////////////////////////////////////////////////

        NAME Retarget

        EXTERN getkey
        EXTERN sendchar

        PUBLIC __stdin
        PUBLIC __stdout
        PUBLIC _sys_exit
        PUBLIC _ttywrch
        PUBLIC ferror
        PUBLIC fgetc
        PUBLIC fputc

// C:\My_App\Project\Template\Retarget.c
//    1 /*----------------------------------------------------------------------------
//    2  * Name:    Retarget.c
//    3  * Purpose: 'Retarget' layer for target-dependent low level functions
//    4  * Version: V1.00
//    5  * Note(s): 
//    6  *----------------------------------------------------------------------------
//    7  * This file is part of the uVision/ARM development tools.
//    8  * This software may only be used under the terms of a valid, current,
//    9  * end user licence from KEIL for a compatible version of KEIL software
//   10  * development tools. Nothing else gives you the right to use this software.
//   11  *
//   12  * This software is supplied "AS IS" without warranties of any kind.
//   13  *
//   14  * Copyright (c) 2008 Keil - An ARM Company. All rights reserved.
//   15  *----------------------------------------------------------------------------
//   16  * History:
//   17  *          V1.00 Initial Version
//   18  *----------------------------------------------------------------------------*/
//   19 
//   20 #include <stdio.h>
//   21 
//   22 extern int sendchar (int c);
//   23 extern int getkey (void);
//   24 
//   25 struct __FILE { int handle; /* Add whatever you need here */ };

        SECTION `.bss`:DATA:NOROOT(2)
//   26 FILE __stdout;
__stdout:
        DS8 4

        SECTION `.bss`:DATA:NOROOT(2)
//   27 FILE __stdin;
__stdin:
        DS8 4
//   28 

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//   29 int fputc(int ch, FILE *f) {
//   30   return (sendchar(ch));
fputc:
        B.W      sendchar
//   31 }
//   32 

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//   33 int fgetc(FILE *f) {
//   34   return (getkey());
fgetc:
        B.W      getkey
//   35 }
//   36 

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//   37 int ferror(FILE *f) {
//   38   /* Your implementation of ferror */
//   39   return EOF;
ferror:
        MOV      R0,#-1
        BX       LR               ;; return
//   40 }
//   41 

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//   42 void _ttywrch(int ch) {
//   43   sendchar(ch);
_ttywrch:
        B.W      sendchar
//   44 }
//   45 

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//   46 void _sys_exit(int return_code) {
//   47 label:  goto label;  /* endless loop */
_sys_exit:
??_sys_exit_0:
        B.N      ??_sys_exit_0
//   48 }

        END
// 
//  8 bytes in section .bss
// 20 bytes in section .text
// 
// 20 bytes of CODE memory
//  8 bytes of DATA memory
//
//Errors: none
//Warnings: none
