///////////////////////////////////////////////////////////////////////////////
//                                                                            /
// IAR ANSI C/C++ Compiler V5.40.0.51500/W32 for ARM    07/Sep/2009  17:30:48 /
// Copyright (C) 1999-2009 IAR Systems AB.                                    /
//                                                                            /
//    Cpu mode     =  thumb                                                   /
//    Endian       =  little                                                  /
//    Source file  =  C:\My_App\Project\Template\i2c_ee.c                     /
//    Command line =  C:\My_App\Project\Template\i2c_ee.c -D                  /
//                    USE_STDPERIPH_DRIVER -D STM32F10X_HD -D                 /
//                    USE_STM3210E_EVAL -lCN C:\My_App\Project\Template\EWARM /
//                    v5\STM3210E-EVAL\List\ -lB                              /
//                    C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\List\  /
//                    -o C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\Obj /
//                    \ --debug --endian=little --cpu=Cortex-M3 -e            /
//                    --fpu=None --dlib_config "C:\Program Files\IAR          /
//                    Systems\Embedded Workbench                              /
//                    5.4\arm\INC\DLib_Config_Full.h" -I                      /
//                    C:\My_App\Project\Template\EWARMv5\..\ -I               /
//                    C:\My_App\Project\Template\EWARMv5\..\..\..\Libraries\C /
//                    MSIS\Core\CM3\ -I C:\My_App\Project\Template\EWARMv5\.. /
//                    \..\..\Libraries\STM32F10x_StdPeriph_Driver\inc\ -I     /
//                    "C:\Program Files\IAR Systems\Embedded Workbench        /
//                    5.4\arm\INC\" -Ohz                                      /
//    List file    =  C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\List\i /
//                    2c_ee.s                                                 /
//                                                                            /
//                                                                            /
///////////////////////////////////////////////////////////////////////////////

        NAME i2c_ee

        EXTERN GPIO_Init
        EXTERN I2C_AcknowledgeConfig
        EXTERN I2C_CheckEvent
        EXTERN I2C_ClearFlag
        EXTERN I2C_Cmd
        EXTERN I2C_GenerateSTART
        EXTERN I2C_GenerateSTOP
        EXTERN I2C_GetFlagStatus
        EXTERN I2C_Init
        EXTERN I2C_ReadRegister
        EXTERN I2C_ReceiveData
        EXTERN I2C_Send7bitAddress
        EXTERN I2C_SendData

        PUBLIC EEPROM_ADDRESS
        PUBLIC GPIO_Configuration
        PUBLIC I2C_Configuration
        PUBLIC I2C_EE_BufferRead
        PUBLIC I2C_EE_BufferWrite
        PUBLIC I2C_EE_ByteWrite
        PUBLIC I2C_EE_Init
        PUBLIC I2C_EE_PageWrite
        PUBLIC I2C_EE_WaitEepromStandbyState

// C:\My_App\Project\Template\i2c_ee.c
//    1 /**
//    2   ******************************************************************************
//    3   * @file I2C/M24C08_EEPROM/i2c_ee.c 
//    4   * @author  MCD Application Team
//    5   * @version  V3.0.0
//    6   * @date  04/06/2009
//    7   * @brief  This file provides a set of functions needed to manage the
//    8   *         communication between I2C peripheral and I2C M24C08 EEPROM.
//    9   ******************************************************************************
//   10   * @copy
//   11   *
//   12   * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
//   13   * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
//   14   * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
//   15   * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//   16   * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
//   17   * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
//   18   *
//   19   * <h2><center>&copy; COPYRIGHT 2009 STMicroelectronics</center></h2>
//   20   */ 
//   21 
//   22 /* Includes ------------------------------------------------------------------*/
//   23 #include "i2c_ee.h"
//   24 
//   25 /** @addtogroup StdPeriph_Examples
//   26   * @{
//   27   */
//   28 
//   29 /** @addtogroup I2C_M24C08_EEPROM
//   30   * @{
//   31   */ 
//   32 
//   33 /* Private typedef -----------------------------------------------------------*/
//   34 /* Private define ------------------------------------------------------------*/
//   35 #define I2C_Speed              400000
//   36 #define I2C1_SLAVE_ADDRESS7    0xA0
//   37 #define I2C_PageSize           8
//   38 
//   39 /* Private macro -------------------------------------------------------------*/
//   40 /* Private variables ---------------------------------------------------------*/

        SECTION `.bss`:DATA:NOROOT(1)
//   41 uint16_t EEPROM_ADDRESS;
EEPROM_ADDRESS:
        DS8 2
//   42 
//   43 /* Private function prototypes -----------------------------------------------*/
//   44 void GPIO_Configuration(void);
//   45 void I2C_Configuration(void);
//   46 
//   47 /* Private functions ---------------------------------------------------------*/
//   48 
//   49 /**
//   50   * @brief  Configure the used I/O ports pin
//   51   * @param  None
//   52   * @retval : None
//   53   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//   54 void GPIO_Configuration(void)
//   55 {
GPIO_Configuration:
        PUSH     {R7,LR}
//   56   GPIO_InitTypeDef  GPIO_InitStructure; 
//   57 
//   58   /* Configure I2C1 pins: SCL and SDA */
//   59   GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_6 | GPIO_Pin_7;
        MOVS     R0,#+192
        STRH     R0,[SP, #+0]
//   60   GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
        MOVS     R0,#+3
        STRB     R0,[SP, #+2]
//   61   GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_OD;
        MOVS     R0,#+28
        STRB     R0,[SP, #+3]
//   62   GPIO_Init(GPIOB, &GPIO_InitStructure);
        ADD      R1,SP,#+0
        LDR.N    R0,??GPIO_Configuration_0  ;; 0x40010c00
        BL       GPIO_Init
//   63 }
        POP      {R0,PC}          ;; return
        Nop      
        DATA
??GPIO_Configuration_0:
        DC32     0x40010c00
//   64 
//   65 /**
//   66   * @brief  I2C Configuration
//   67   * @param  None
//   68   * @retval : None
//   69   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//   70 void I2C_Configuration(void)
//   71 {
I2C_Configuration:
        PUSH     {R0-R4,LR}
//   72   I2C_InitTypeDef  I2C_InitStructure; 
//   73 
//   74   /* I2C configuration */
//   75   I2C_InitStructure.I2C_Mode = I2C_Mode_I2C;
        MOVS     R0,#+0
        STRH     R0,[SP, #+0]
//   76   I2C_InitStructure.I2C_DutyCycle = I2C_DutyCycle_2;
        MOVW     R0,#+49151
        STRH     R0,[SP, #+2]
//   77   I2C_InitStructure.I2C_OwnAddress1 = I2C1_SLAVE_ADDRESS7;
        MOVS     R0,#+160
        STRH     R0,[SP, #+4]
//   78   I2C_InitStructure.I2C_Ack = I2C_Ack_Enable;
        MOV      R0,#+1024
        STRH     R0,[SP, #+6]
//   79   I2C_InitStructure.I2C_AcknowledgedAddress = I2C_AcknowledgedAddress_7bit;
        MOV      R0,#+16384
        STRH     R0,[SP, #+8]
//   80   I2C_InitStructure.I2C_ClockSpeed = I2C_Speed;
        LDR.N    R0,??I2C_Configuration_0  ;; 0x61a80
        STR      R0,[SP, #+12]
//   81   
//   82   /* I2C Peripheral Enable */
//   83   I2C_Cmd(I2C1, ENABLE);
        LDR.N    R4,??DataTable16  ;; 0x40005400
        MOVS     R1,#+1
        MOV      R0,R4
        BL       I2C_Cmd
//   84   /* Apply I2C configuration after enabling it */
//   85   I2C_Init(I2C1, &I2C_InitStructure);
        ADD      R1,SP,#+0
        MOV      R0,R4
        BL       I2C_Init
//   86 }
        POP      {R0-R4,PC}       ;; return
        Nop      
        DATA
??I2C_Configuration_0:
        DC32     0x61a80
//   87 
//   88 /**
//   89   * @brief  Initializes peripherals used by the I2C EEPROM driver.
//   90   * @param  None
//   91   * @retval : None
//   92   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//   93 void I2C_EE_Init()
//   94 {
I2C_EE_Init:
        PUSH     {R7,LR}
//   95   /* GPIO configuration */
//   96   GPIO_Configuration();
        BL       GPIO_Configuration
//   97 
//   98   /* I2C configuration */
//   99   I2C_Configuration();
        BL       I2C_Configuration
//  100 
//  101   /* depending on the EEPROM Address selected in the i2c_ee.h file */
//  102   /* Select the EEPROM Block0 to write on */
//  103   EEPROM_ADDRESS = EEPROM_Block_ADDRESS;
        LDR.N    R0,??DataTable15  ;; EEPROM_ADDRESS
        MOVS     R1,#+160
        STRH     R1,[R0, #+0]
//  104 }
        POP      {R0,PC}          ;; return
//  105 
//  106 /**
//  107   * @brief  Writes buffer of data to the I2C EEPROM.
//  108   * @param pBuffer : pointer to the buffer  containing the data to be 
//  109   *   written to the EEPROM.
//  110   * @param WriteAddr : EEPROM's internal address to write to.
//  111   * @param NumByteToWrite : number of bytes to write to the EEPROM.
//  112   * @retval : None
//  113   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  114 void I2C_EE_BufferWrite(uint8_t* pBuffer, uint8_t WriteAddr, uint16_t NumByteToWrite)
//  115 {
I2C_EE_BufferWrite:
        PUSH     {R4-R8,LR}
        MOV      R5,R0
        MOV      R4,R1
//  116   uint8_t NumOfPage = 0, NumOfSingle = 0, Addr = 0, count = 0;
//  117 
//  118   Addr = WriteAddr % I2C_PageSize;
        AND      R0,R4,#0x7
//  119   count = I2C_PageSize - Addr;
        RSB      R6,R0,#+8
        UXTB     R6,R6
//  120   NumOfPage =  NumByteToWrite / I2C_PageSize;
        LSRS     R7,R2,#+3
//  121   NumOfSingle = NumByteToWrite % I2C_PageSize;
        AND      R8,R2,#0x7
//  122  
//  123   /* If WriteAddr is I2C_PageSize aligned  */
//  124   if(Addr == 0) 
        CMP      R0,#+0
        UXTB     R7,R7
        BNE.N    ??I2C_EE_BufferWrite_0
//  125   {
//  126     /* If NumByteToWrite < I2C_PageSize */
//  127     if(NumOfPage == 0) 
        CBNZ     R7,??I2C_EE_BufferWrite_1
//  128     {
//  129       I2C_EE_PageWrite(pBuffer, WriteAddr, NumOfSingle);
??I2C_EE_BufferWrite_2:
        MOV      R2,R8
        BL       ??Subroutine1_0
//  130       I2C_EE_WaitEepromStandbyState();
??CrossCallReturnLabel_3:
        BL       I2C_EE_WaitEepromStandbyState
//  131     }
//  132     /* If NumByteToWrite > I2C_PageSize */
//  133     else  
//  134     {
//  135       while(NumOfPage--)
//  136       {
//  137         I2C_EE_PageWrite(pBuffer, WriteAddr, I2C_PageSize); 
//  138     	I2C_EE_WaitEepromStandbyState();
//  139         WriteAddr +=  I2C_PageSize;
//  140         pBuffer += I2C_PageSize;
//  141       }
//  142 
//  143       if(NumOfSingle!=0)
//  144       {
//  145         I2C_EE_PageWrite(pBuffer, WriteAddr, NumOfSingle);
//  146         I2C_EE_WaitEepromStandbyState();
//  147       }
//  148     }
//  149   }
//  150   /* If WriteAddr is not I2C_PageSize aligned  */
//  151   else 
//  152   {
//  153     /* If NumByteToWrite < I2C_PageSize */
//  154     if(NumOfPage== 0) 
//  155     {
//  156       I2C_EE_PageWrite(pBuffer, WriteAddr, NumOfSingle);
//  157       I2C_EE_WaitEepromStandbyState();
//  158     }
//  159     /* If NumByteToWrite > I2C_PageSize */
//  160     else
//  161     {
//  162       NumByteToWrite -= count;
//  163       NumOfPage =  NumByteToWrite / I2C_PageSize;
//  164       NumOfSingle = NumByteToWrite % I2C_PageSize;	
//  165       
//  166       if(count != 0)
//  167       {  
//  168         I2C_EE_PageWrite(pBuffer, WriteAddr, count);
//  169         I2C_EE_WaitEepromStandbyState();
//  170         WriteAddr += count;
//  171         pBuffer += count;
//  172       } 
//  173       
//  174       while(NumOfPage--)
//  175       {
//  176         I2C_EE_PageWrite(pBuffer, WriteAddr, I2C_PageSize);
//  177         I2C_EE_WaitEepromStandbyState();
//  178         WriteAddr +=  I2C_PageSize;
//  179         pBuffer += I2C_PageSize;  
//  180       }
//  181       if(NumOfSingle != 0)
//  182       {
//  183         I2C_EE_PageWrite(pBuffer, WriteAddr, NumOfSingle); 
//  184         I2C_EE_WaitEepromStandbyState();
//  185       }
//  186     }
//  187   }  
//  188 }
??I2C_EE_BufferWrite_3:
        POP      {R4-R8,PC}       ;; return
??I2C_EE_BufferWrite_4:
        BL       ?Subroutine1
??CrossCallReturnLabel_5:
        BL       I2C_EE_WaitEepromStandbyState
        ADDS     R4,R4,#+8
        ADDS     R5,R5,#+8
??I2C_EE_BufferWrite_1:
        BL       ?Subroutine3
??CrossCallReturnLabel_10:
        BNE.N    ??I2C_EE_BufferWrite_4
??I2C_EE_BufferWrite_5:
        CMP      R8,#+0
        BNE.N    ??I2C_EE_BufferWrite_2
        B.N      ??I2C_EE_BufferWrite_3
??I2C_EE_BufferWrite_0:
        CMP      R7,#+0
        BEQ.N    ??I2C_EE_BufferWrite_2
        SUBS     R2,R2,R6
        UXTH     R2,R2
        LSRS     R7,R2,#+3
        AND      R8,R2,#0x7
        CBZ      R6,??I2C_EE_BufferWrite_6
        MOV      R2,R6
        MOV      R0,R5
        BL       I2C_EE_PageWrite
        BL       I2C_EE_WaitEepromStandbyState
        ADDS     R4,R6,R4
        ADDS     R5,R6,R5
??I2C_EE_BufferWrite_6:
        BL       ?Subroutine3
??CrossCallReturnLabel_11:
        BEQ.N    ??I2C_EE_BufferWrite_5
        BL       ?Subroutine1
??CrossCallReturnLabel_4:
        BL       I2C_EE_WaitEepromStandbyState
        ADDS     R4,R4,#+8
        ADDS     R5,R5,#+8
        B.N      ??I2C_EE_BufferWrite_6

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
?Subroutine3:
        MOV      R0,R7
        ADD      R7,R0,#+255
        UXTB     R0,R0
        CMP      R0,#+0
        BX       LR

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
?Subroutine1:
        MOVS     R2,#+8
??Subroutine1_0:
        UXTB     R1,R4
        MOV      R0,R5
        B.N      I2C_EE_PageWrite
//  189 
//  190 /**
//  191   * @brief  Writes one byte to the I2C EEPROM.
//  192   * @param pBuffer : pointer to the buffer  containing the data to be 
//  193   *   written to the EEPROM.
//  194   * @param WriteAddr : EEPROM's internal address to write to.
//  195   * @retval : None
//  196   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  197 void I2C_EE_ByteWrite(uint8_t* pBuffer, uint8_t WriteAddr)
//  198 {
I2C_EE_ByteWrite:
        PUSH     {R4-R6,LR}
        MOV      R4,R0
        MOV      R5,R1
//  199   /* Send STRAT condition */
//  200   I2C_GenerateSTART(I2C1, ENABLE);
        LDR.N    R6,??DataTable16  ;; 0x40005400
        BL       ?Subroutine0
//  201 
//  202   /* Test on EV5 and clear it */
//  203   while(!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_MODE_SELECT));  
??CrossCallReturnLabel_2:
        LDR.N    R1,??DataTable11  ;; 0x30001
        BL       ??Subroutine4_0
??CrossCallReturnLabel_19:
        CMP      R0,#+0
        BEQ.N    ??CrossCallReturnLabel_2
//  204 
//  205   /* Send EEPROM address for write */
//  206   I2C_Send7bitAddress(I2C1, EEPROM_ADDRESS, I2C_Direction_Transmitter);
        BL       ?Subroutine5
??CrossCallReturnLabel_22:
        MOV      R0,R6
        BL       I2C_Send7bitAddress
//  207   
//  208   /* Test on EV6 and clear it */
//  209   while(!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED));
??I2C_EE_ByteWrite_0:
        BL       ?Subroutine4
??CrossCallReturnLabel_21:
        CMP      R0,#+0
        BEQ.N    ??I2C_EE_ByteWrite_0
//  210       
//  211   /* Send the EEPROM's internal address to write to */
//  212   I2C_SendData(I2C1, WriteAddr);
        MOV      R1,R5
        MOV      R0,R6
        BL       I2C_SendData
        LDR.N    R5,??DataTable13  ;; 0x70084
//  213   
//  214   /* Test on EV8 and clear it */
//  215   while(!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_BYTE_TRANSMITTED));
??I2C_EE_ByteWrite_1:
        MOV      R1,R5
        BL       ??Subroutine4_0
??CrossCallReturnLabel_18:
        CMP      R0,#+0
        BEQ.N    ??I2C_EE_ByteWrite_1
//  216 
//  217   /* Send the byte to be written */
//  218   I2C_SendData(I2C1, *pBuffer); 
        LDRB     R1,[R4, #+0]
        MOV      R0,R6
        BL       I2C_SendData
//  219    
//  220   /* Test on EV8 and clear it */
//  221   while(!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_BYTE_TRANSMITTED));
??I2C_EE_ByteWrite_2:
        MOV      R1,R5
        BL       ??Subroutine4_0
??CrossCallReturnLabel_17:
        CMP      R0,#+0
        BEQ.N    ??I2C_EE_ByteWrite_2
//  222   
//  223   /* Send STOP condition */
//  224   I2C_GenerateSTOP(I2C1, ENABLE);
        MOVS     R1,#+1
        MOV      R0,R6
        POP      {R4-R6,LR}
        B.W      I2C_GenerateSTOP
//  225 }
//  226 
//  227 /**
//  228   * @brief  Writes more than one byte to the EEPROM with a single WRITE
//  229   *   cycle. The number of byte can't exceed the EEPROM page size.
//  230   * @param pBuffer : pointer to the buffer containing the data to be 
//  231   *   written to the EEPROM.
//  232   * @param WriteAddr : EEPROM's internal address to write to.
//  233   * @param NumByteToWrite : number of bytes to write to the EEPROM.
//  234   * @retval : None
//  235   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  236 void I2C_EE_PageWrite(uint8_t* pBuffer, uint8_t WriteAddr, uint8_t NumByteToWrite)
//  237 {
I2C_EE_PageWrite:
        PUSH     {R3-R7,LR}
        MOV      R4,R0
        MOV      R7,R1
        MOV      R6,R2
        LDR.N    R5,??DataTable16  ;; 0x40005400
//  238   /* While the bus is busy */
//  239   while(I2C_GetFlagStatus(I2C1, I2C_FLAG_BUSY));
??I2C_EE_PageWrite_0:
        MOV      R1,#+131072
        MOV      R0,R5
        BL       I2C_GetFlagStatus
        CMP      R0,#+0
        BNE.N    ??I2C_EE_PageWrite_0
//  240   
//  241   /* Send START condition */
//  242   I2C_GenerateSTART(I2C1, ENABLE);
        MOVS     R1,#+1
        MOV      R0,R5
        BL       I2C_GenerateSTART
//  243   
//  244   /* Test on EV5 and clear it */
//  245   while(!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_MODE_SELECT)); 
??I2C_EE_PageWrite_1:
        LDR.N    R1,??DataTable11  ;; 0x30001
        BL       ??Subroutine2_0
??CrossCallReturnLabel_7:
        CMP      R0,#+0
        BEQ.N    ??I2C_EE_PageWrite_1
//  246   
//  247   /* Send EEPROM address for write */
//  248   I2C_Send7bitAddress(I2C1, EEPROM_ADDRESS, I2C_Direction_Transmitter);
        BL       ?Subroutine5
??CrossCallReturnLabel_23:
        MOV      R0,R5
        BL       I2C_Send7bitAddress
//  249 
//  250   /* Test on EV6 and clear it */
//  251   while(!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED));  
??I2C_EE_PageWrite_2:
        LDR.N    R1,??DataTable14  ;; 0x70082
        BL       ??Subroutine2_0
??CrossCallReturnLabel_6:
        CMP      R0,#+0
        BEQ.N    ??I2C_EE_PageWrite_2
//  252 
//  253   /* Send the EEPROM's internal address to write to */    
//  254   I2C_SendData(I2C1, WriteAddr);  
        MOV      R1,R7
        MOV      R0,R5
        BL       I2C_SendData
        LDR.N    R7,??DataTable13  ;; 0x70084
//  255 
//  256   /* Test on EV8 and clear it */
//  257   while(! I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_BYTE_TRANSMITTED));
??I2C_EE_PageWrite_3:
        BL       ?Subroutine2
??CrossCallReturnLabel_9:
        CMP      R0,#+0
        BEQ.N    ??I2C_EE_PageWrite_3
//  258 
//  259   /* While there is data to be written */
//  260   while(NumByteToWrite--)  
??I2C_EE_PageWrite_4:
        MOV      R0,R6
        ADD      R6,R0,#+255
        UXTB     R0,R0
        CBZ      R0,??I2C_EE_PageWrite_5
//  261   {
//  262     /* Send the current byte */
//  263     I2C_SendData(I2C1, *pBuffer); 
        LDRB     R1,[R4], #+1
        MOV      R0,R5
        BL       I2C_SendData
//  264 
//  265     /* Point to the next byte to be written */
//  266     pBuffer++; 
//  267   
//  268     /* Test on EV8 and clear it */
//  269     while (!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_BYTE_TRANSMITTED));
??I2C_EE_PageWrite_6:
        BL       ?Subroutine2
//  270   }
??CrossCallReturnLabel_8:
        CMP      R0,#+0
        BNE.N    ??I2C_EE_PageWrite_4
        B.N      ??I2C_EE_PageWrite_6
//  271 
//  272   /* Send STOP condition */
//  273   I2C_GenerateSTOP(I2C1, ENABLE);
??I2C_EE_PageWrite_5:
        MOVS     R1,#+1
        MOV      R0,R5
        POP      {R2,R4-R7,LR}
        B.W      I2C_GenerateSTOP
//  274 }

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
?Subroutine5:
        MOVS     R2,#+0
        LDR.N    R0,??DataTable15  ;; EEPROM_ADDRESS
        LDRH     R1,[R0, #+0]
        UXTB     R1,R1
        BX       LR

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
?Subroutine2:
        MOV      R1,R7
??Subroutine2_0:
        MOV      R0,R5
        B.W      I2C_CheckEvent
//  275 
//  276 /**
//  277   * @brief  Reads a block of data from the EEPROM.
//  278   * @param pBuffer : pointer to the buffer that receives the data read 
//  279   *   from the EEPROM.
//  280   * @param ReadAddr : EEPROM's internal address to read from.
//  281   * @param NumByteToRead : number of bytes to read from the EEPROM.
//  282   * @retval : None
//  283   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  284 void I2C_EE_BufferRead(uint8_t* pBuffer, uint8_t ReadAddr, uint16_t NumByteToRead)
//  285 {  
I2C_EE_BufferRead:
        PUSH     {R3-R9,LR}
        MOV      R4,R0
        MOV      R9,R1
        MOV      R5,R2
        LDR.N    R6,??DataTable16  ;; 0x40005400
//  286     /* While the bus is busy */
//  287   while(I2C_GetFlagStatus(I2C1, I2C_FLAG_BUSY));
??I2C_EE_BufferRead_0:
        MOV      R1,#+131072
        MOV      R0,R6
        BL       I2C_GetFlagStatus
        CMP      R0,#+0
        BNE.N    ??I2C_EE_BufferRead_0
//  288   
//  289   /* Send START condition */
//  290   I2C_GenerateSTART(I2C1, ENABLE);
        BL       ?Subroutine0
??CrossCallReturnLabel_1:
        LDR.W    R8,??DataTable11  ;; 0x30001
//  291   
//  292   /* Test on EV5 and clear it */
//  293   while(!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_MODE_SELECT));
??I2C_EE_BufferRead_1:
        MOV      R1,R8
        BL       ??Subroutine4_0
??CrossCallReturnLabel_16:
        CMP      R0,#+0
        BEQ.N    ??I2C_EE_BufferRead_1
//  294    
//  295   /* Send EEPROM address for write */
//  296   I2C_Send7bitAddress(I2C1, EEPROM_ADDRESS, I2C_Direction_Transmitter);
        LDR.N    R7,??DataTable15  ;; EEPROM_ADDRESS
        MOVS     R2,#+0
        BL       ?Subroutine6
//  297 
//  298   /* Test on EV6 and clear it */
//  299   while(!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED));
??CrossCallReturnLabel_25:
        BL       ?Subroutine4
??CrossCallReturnLabel_20:
        CMP      R0,#+0
        BEQ.N    ??CrossCallReturnLabel_25
//  300   
//  301   /* Clear EV6 by setting again the PE bit */
//  302   I2C_Cmd(I2C1, ENABLE);
        MOVS     R1,#+1
        MOV      R0,R6
        BL       I2C_Cmd
//  303 
//  304   /* Send the EEPROM's internal address to write to */
//  305   I2C_SendData(I2C1, ReadAddr);  
        MOV      R1,R9
        MOV      R0,R6
        BL       I2C_SendData
//  306 
//  307   /* Test on EV8 and clear it */
//  308   while(!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_BYTE_TRANSMITTED));
??I2C_EE_BufferRead_2:
        LDR.N    R1,??DataTable13  ;; 0x70084
        BL       ??Subroutine4_0
??CrossCallReturnLabel_15:
        CMP      R0,#+0
        BEQ.N    ??I2C_EE_BufferRead_2
//  309   
//  310   /* Send STRAT condition a second time */  
//  311   I2C_GenerateSTART(I2C1, ENABLE);
        BL       ?Subroutine0
//  312   
//  313   /* Test on EV5 and clear it */
//  314   while(!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_MODE_SELECT));
??CrossCallReturnLabel_0:
        MOV      R1,R8
        BL       ??Subroutine4_0
??CrossCallReturnLabel_14:
        CMP      R0,#+0
        BEQ.N    ??CrossCallReturnLabel_0
//  315   
//  316   /* Send EEPROM address for read */
//  317   I2C_Send7bitAddress(I2C1, EEPROM_ADDRESS, I2C_Direction_Receiver);
        MOVS     R2,#+1
        BL       ?Subroutine6
//  318   
//  319   /* Test on EV6 and clear it */
//  320   while(!I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED));
??CrossCallReturnLabel_24:
        LDR.N    R1,??I2C_EE_BufferRead_3  ;; 0x30002
        BL       ??Subroutine4_0
??CrossCallReturnLabel_13:
        CMP      R0,#+0
        BEQ.N    ??CrossCallReturnLabel_24
//  321   
//  322   /* While there is data to be read */
//  323   while(NumByteToRead)  
??I2C_EE_BufferRead_4:
        UXTH     R5,R5
        CBZ      R5,??I2C_EE_BufferRead_5
//  324   {
//  325     if(NumByteToRead == 1)
??I2C_EE_BufferRead_6:
        CMP      R5,#+1
        BNE.N    ??I2C_EE_BufferRead_7
//  326     {
//  327       /* Disable Acknowledgement */
//  328       I2C_AcknowledgeConfig(I2C1, DISABLE);
        MOVS     R1,#+0
        MOV      R0,R6
        BL       I2C_AcknowledgeConfig
//  329       
//  330       /* Send STOP Condition */
//  331       I2C_GenerateSTOP(I2C1, ENABLE);
        MOVS     R1,#+1
        MOV      R0,R6
        BL       I2C_GenerateSTOP
//  332     }
//  333 
//  334     /* Test on EV7 and clear it */
//  335     if(I2C_CheckEvent(I2C1, I2C_EVENT_MASTER_BYTE_RECEIVED))  
??I2C_EE_BufferRead_7:
        LDR.N    R1,??I2C_EE_BufferRead_3+0x4  ;; 0x30040
        BL       ??Subroutine4_0
??CrossCallReturnLabel_12:
        CMP      R0,#+0
        BEQ.N    ??I2C_EE_BufferRead_6
//  336     {      
//  337       /* Read a byte from the EEPROM */
//  338       *pBuffer = I2C_ReceiveData(I2C1);
        MOV      R0,R6
        BL       I2C_ReceiveData
        STRB     R0,[R4], #+1
//  339 
//  340       /* Point to the next location where the byte read will be saved */
//  341       pBuffer++; 
//  342       
//  343       /* Decrement the read bytes counter */
//  344       NumByteToRead--;        
        SUBS     R5,R5,#+1
        B.N      ??I2C_EE_BufferRead_4
//  345     }   
//  346   }
//  347 
//  348   /* Enable Acknowledgement to be ready for another reception */
//  349   I2C_AcknowledgeConfig(I2C1, ENABLE);
??I2C_EE_BufferRead_5:
        MOVS     R1,#+1
        MOV      R0,R6
        POP      {R2,R4-R9,LR}
        B.W      I2C_AcknowledgeConfig
        DATA
??I2C_EE_BufferRead_3:
        DC32     0x30002
        DC32     0x30040
//  350 }

        SECTION `.text`:CODE:NOROOT(2)
        DATA
??DataTable11:
        DC32     0x30001

        SECTION `.text`:CODE:NOROOT(2)
        DATA
??DataTable13:
        DC32     0x70084

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
?Subroutine6:
        LDRH     R1,[R7, #+0]
        UXTB     R1,R1
        MOV      R0,R6
        B.W      I2C_Send7bitAddress

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
?Subroutine4:
        LDR.N    R1,??DataTable14  ;; 0x70082
??Subroutine4_0:
        MOV      R0,R6
        B.W      I2C_CheckEvent

        SECTION `.text`:CODE:NOROOT(2)
        DATA
??DataTable14:
        DC32     0x70082

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
?Subroutine0:
        MOVS     R1,#+1
        MOV      R0,R6
        B.W      I2C_GenerateSTART
//  351 
//  352 /**
//  353   * @brief  Wait for EEPROM Standby state
//  354   * @param  None
//  355   * @retval : None
//  356   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  357 void I2C_EE_WaitEepromStandbyState(void)      
//  358 {
I2C_EE_WaitEepromStandbyState:
        PUSH     {R3-R5,LR}
//  359   __IO uint16_t SR1_Tmp = 0;
        MOVS     R0,#+0
        STRH     R0,[SP, #+0]
        LDR.N    R4,??DataTable15  ;; EEPROM_ADDRESS
        LDR.N    R5,??DataTable16  ;; 0x40005400
//  360 
//  361   do
//  362   {
//  363     /* Send START condition */
//  364     I2C_GenerateSTART(I2C1, ENABLE);
??I2C_EE_WaitEepromStandbyState_0:
        MOVS     R1,#+1
        MOV      R0,R5
        BL       I2C_GenerateSTART
//  365     /* Read I2C1 SR1 register */
//  366     SR1_Tmp = I2C_ReadRegister(I2C1, I2C_Register_SR1);
        MOVS     R1,#+20
        MOV      R0,R5
        BL       I2C_ReadRegister
        STRH     R0,[SP, #+0]
//  367     /* Send EEPROM address for write */
//  368     I2C_Send7bitAddress(I2C1, EEPROM_ADDRESS, I2C_Direction_Transmitter);
        MOVS     R2,#+0
        LDRH     R1,[R4, #+0]
        UXTB     R1,R1
        MOV      R0,R5
        BL       I2C_Send7bitAddress
//  369   }while(!(I2C_ReadRegister(I2C1, I2C_Register_SR1) & 0x0002));
        MOVS     R1,#+20
        MOV      R0,R5
        BL       I2C_ReadRegister
        LSLS     R0,R0,#+30
        BPL.N    ??I2C_EE_WaitEepromStandbyState_0
//  370   
//  371   /* Clear AF flag */
//  372   I2C_ClearFlag(I2C1, I2C_FLAG_AF);
        LDR.N    R1,??I2C_EE_WaitEepromStandbyState_1  ;; 0x10000400
        MOV      R0,R5
        BL       I2C_ClearFlag
//  373   
//  374   /* STOP condition */    
//  375   I2C_GenerateSTOP(I2C1, ENABLE);  
        MOVS     R1,#+1
        MOV      R0,R5
        POP      {R2,R4,R5,LR}
        B.W      I2C_GenerateSTOP
        DATA
??I2C_EE_WaitEepromStandbyState_1:
        DC32     0x10000400
//  376 }

        SECTION `.text`:CODE:NOROOT(2)
        DATA
??DataTable15:
        DC32     EEPROM_ADDRESS

        SECTION `.text`:CODE:NOROOT(2)
        DATA
??DataTable16:
        DC32     0x40005400

        END
//  377 
//  378 /**
//  379   * @}
//  380   */ 
//  381 
//  382 /**
//  383   * @}
//  384   */ 
//  385 
//  386 /******************* (C) COPYRIGHT 2009 STMicroelectronics *****END OF FILE****/
// 
//   2 bytes in section .bss
// 806 bytes in section .text
// 
// 806 bytes of CODE memory
//   2 bytes of DATA memory
//
//Errors: none
//Warnings: none
