///////////////////////////////////////////////////////////////////////////////
//                                                                            /
// IAR ANSI C/C++ Compiler V5.40.0.51500/W32 for ARM    07/Sep/2009  17:30:49 /
// Copyright (C) 1999-2009 IAR Systems AB.                                    /
//                                                                            /
//    Cpu mode     =  thumb                                                   /
//    Endian       =  little                                                  /
//    Source file  =  C:\My_App\Project\Template\Getline.c                    /
//    Command line =  C:\My_App\Project\Template\Getline.c -D                 /
//                    USE_STDPERIPH_DRIVER -D STM32F10X_HD -D                 /
//                    USE_STM3210E_EVAL -lCN C:\My_App\Project\Template\EWARM /
//                    v5\STM3210E-EVAL\List\ -lB                              /
//                    C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\List\  /
//                    -o C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\Obj /
//                    \ --debug --endian=little --cpu=Cortex-M3 -e            /
//                    --fpu=None --dlib_config "C:\Program Files\IAR          /
//                    Systems\Embedded Workbench                              /
//                    5.4\arm\INC\DLib_Config_Full.h" -I                      /
//                    C:\My_App\Project\Template\EWARMv5\..\ -I               /
//                    C:\My_App\Project\Template\EWARMv5\..\..\..\Libraries\C /
//                    MSIS\Core\CM3\ -I C:\My_App\Project\Template\EWARMv5\.. /
//                    \..\..\Libraries\STM32F10x_StdPeriph_Driver\inc\ -I     /
//                    "C:\Program Files\IAR Systems\Embedded Workbench        /
//                    5.4\arm\INC\" -Ohz                                      /
//    List file    =  C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\List\G /
//                    etline.s                                                /
//                                                                            /
//                                                                            /
///////////////////////////////////////////////////////////////////////////////

        NAME Getline

        EXTERN getkey
        EXTERN putchar

        PUBLIC getline

// C:\My_App\Project\Template\Getline.c
//    1 /*----------------------------------------------------------------------------
//    2  * Name:    Getline.c
//    3  * Purpose: Line Edited Character Input
//    4  * Version: V1.00
//    5  * Note(s): 
//    6  *----------------------------------------------------------------------------
//    7  * This file is part of the uVision/ARM development tools.
//    8  * This software may only be used under the terms of a valid, current,
//    9  * end user licence from KEIL for a compatible version of KEIL software
//   10  * development tools. Nothing else gives you the right to use this software.
//   11  *
//   12  * This software is supplied "AS IS" without warranties of any kind.
//   13  *
//   14  * Copyright (c) 2008 Keil - An ARM Company. All rights reserved.
//   15  *----------------------------------------------------------------------------
//   16  * History:
//   17  *          V1.00 Initial Version
//   18  *----------------------------------------------------------------------------*/
//   19 
//   20 #include <stdio.h>
//   21 #include "measure.h"                     /* global project definition file   */
//   22 
//   23 #define CNTLQ      0x11
//   24 #define CNTLS      0x13
//   25 #define DEL        0x7F
//   26 #define BACKSPACE  0x08
//   27 #define CR         0x0D
//   28 #define LF         0x0A
//   29 
//   30 /*------------------------------------------------------------------------------
//   31   Line Editor
//   32  *------------------------------------------------------------------------------*/

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//   33 void getline (char *line, int n)  {
getline:
        PUSH     {R3-R7,LR}
        MOV      R5,R0
        MOV      R4,R1
//   34   int  cnt = 0;
        MOVS     R6,#+0
//   35   char c;
//   36 
//   37   do  {
//   38     if ((c = getkey ()) == CR)  c = LF;     /* read character                 */
??getline_0:
        BL       getkey
        UXTB     R7,R0
        CMP      R7,#+13
        BNE.N    ??getline_1
        MOVS     R7,#+10
        B.N      ??getline_2
//   39     if (c == BACKSPACE  ||  c == DEL)  {    /* process backspace              */
??getline_1:
        CMP      R7,#+8
        BEQ.N    ??getline_3
        CMP      R7,#+127
        BNE.N    ??getline_4
//   40       if (cnt != 0)  {
??getline_3:
        CBZ      R6,??getline_5
//   41         cnt--;                              /* decrement count                */
        SUBS     R6,R6,#+1
//   42         line--;                             /* and line pointer               */
        SUBS     R5,R5,#+1
//   43         putchar (BACKSPACE);                /* echo backspace                 */
        MOVS     R0,#+8
        BL       putchar
//   44         putchar (' ');
        MOVS     R0,#+32
        BL       putchar
//   45         putchar (BACKSPACE);
        MOVS     R0,#+8
        BL       putchar
        B.N      ??getline_5
//   46       }
//   47     }
//   48     else if (c != CNTLQ && c != CNTLS)  {   /* ignore Control S/Q             */
??getline_4:
        CMP      R7,#+17
        BEQ.N    ??getline_5
        CMP      R7,#+19
        BEQ.N    ??getline_5
//   49       putchar (*line = c);                  /* echo and store character       */
??getline_2:
        STRB     R7,[R5, #+0]
        LDRB     R0,[R5], #+1
        BL       putchar
//   50       line++;                               /* increment line pointer         */
//   51       cnt++;                                /* and count                      */
        ADDS     R6,R6,#+1
//   52     }
//   53   }  while (cnt < n - 1  &&  c != LF);      /* check limit and line feed      */
??getline_5:
        SUBS     R0,R4,#+1
        CMP      R6,R0
        BGE.N    ??getline_6
        CMP      R7,#+10
        BNE.N    ??getline_0
//   54   *(line - 1) = 0;                          /* mark end of string             */
??getline_6:
        MOVS     R0,#+0
        STRB     R0,[R5, #-1]
//   55 }
        POP      {R0,R4-R7,PC}    ;; return

        END
// 
// 94 bytes in section .text
// 
// 94 bytes of CODE memory
//
//Errors: none
//Warnings: none
