///////////////////////////////////////////////////////////////////////////////
//                                                                            /
// IAR ANSI C/C++ Compiler V5.40.0.51500/W32 for ARM    07/Sep/2009  17:30:48 /
// Copyright (C) 1999-2009 IAR Systems AB.                                    /
//                                                                            /
//    Cpu mode     =  thumb                                                   /
//    Endian       =  little                                                  /
//    Source file  =  C:\My_App\Project\Template\Serial.c                     /
//    Command line =  C:\My_App\Project\Template\Serial.c -D                  /
//                    USE_STDPERIPH_DRIVER -D STM32F10X_HD -D                 /
//                    USE_STM3210E_EVAL -lCN C:\My_App\Project\Template\EWARM /
//                    v5\STM3210E-EVAL\List\ -lB                              /
//                    C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\List\  /
//                    -o C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\Obj /
//                    \ --debug --endian=little --cpu=Cortex-M3 -e            /
//                    --fpu=None --dlib_config "C:\Program Files\IAR          /
//                    Systems\Embedded Workbench                              /
//                    5.4\arm\INC\DLib_Config_Full.h" -I                      /
//                    C:\My_App\Project\Template\EWARMv5\..\ -I               /
//                    C:\My_App\Project\Template\EWARMv5\..\..\..\Libraries\C /
//                    MSIS\Core\CM3\ -I C:\My_App\Project\Template\EWARMv5\.. /
//                    \..\..\Libraries\STM32F10x_StdPeriph_Driver\inc\ -I     /
//                    "C:\Program Files\IAR Systems\Embedded Workbench        /
//                    5.4\arm\INC\" -Ohz                                      /
//    List file    =  C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\List\S /
//                    erial.s                                                 /
//                                                                            /
//                                                                            /
///////////////////////////////////////////////////////////////////////////////

        NAME Serial

        EXTERN USART_GetFlagStatus
        EXTERN USART_ReceiveData
        EXTERN USART_SendData

        PUBLIC getkey
        PUBLIC sendchar

// C:\My_App\Project\Template\Serial.c
//    1 /*----------------------------------------------------------------------------
//    2  * Name:    Serial.c
//    3  * Purpose: Low level serial routines for STM32
//    4  * Version: V1.00
//    5  * Note(s): 
//    6  *----------------------------------------------------------------------------
//    7  * This file is part of the uVision/ARM development tools.
//    8  * This software may only be used under the terms of a valid, current,
//    9  * end user licence from KEIL for a compatible version of KEIL software
//   10  * development tools. Nothing else gives you the right to use this software.
//   11  *
//   12  * This software is supplied "AS IS" without warranties of any kind.
//   13  *
//   14  * Copyright (c) 2008 Keil - An ARM Company. All rights reserved.
//   15  *----------------------------------------------------------------------------
//   16  * History:
//   17  *          V1.00 Initial Version
//   18  *----------------------------------------------------------------------------*/
//   19 
//   20 #include "stm32f10x.h"
//   21 #include "platform_config.h"
//   22 
//   23 /*----------------------------------------------------------------------------
//   24   Write character to Serial Port
//   25  *----------------------------------------------------------------------------*/

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//   26 int sendchar (int c) {
sendchar:
        PUSH     {R3-R5,LR}
        MOV      R4,R0
//   27 
//   28   if (c == '\n')  {
        LDR.N    R5,??DataTable1  ;; 0x40013800
        CMP      R4,#+10
        BNE.N    ??sendchar_0
//   29     while(USART_GetFlagStatus(USARTx, USART_FLAG_TXE) == RESET);
??sendchar_1:
        MOVS     R1,#+128
        MOV      R0,R5
        BL       USART_GetFlagStatus
        CMP      R0,#+0
        BEQ.N    ??sendchar_1
//   30     USART_SendData(USARTx, 0x0D);
        MOVS     R1,#+13
        MOV      R0,R5
        BL       USART_SendData
//   31   }
//   32   while(USART_GetFlagStatus(USARTx, USART_FLAG_TXE) == RESET);
??sendchar_0:
        MOVS     R1,#+128
        MOV      R0,R5
        BL       USART_GetFlagStatus
        CMP      R0,#+0
        BEQ.N    ??sendchar_0
//   33   USART_SendData(USARTx, (u8) c);
        UXTB     R1,R4
        MOV      R0,R5
        BL       USART_SendData
//   34 
//   35   return (c);
        MOV      R0,R4
        POP      {R1,R4,R5,PC}    ;; return
//   36 }
//   37 
//   38 /*----------------------------------------------------------------------------
//   39   Read character from Serial Port   (blocking read)
//   40  *----------------------------------------------------------------------------*/

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//   41 int getkey (void) {
getkey:
        PUSH     {R4,LR}
        LDR.N    R4,??DataTable1  ;; 0x40013800
//   42 
//   43   while(USART_GetFlagStatus(USARTx,USART_IT_RXNE)==RESET);
??getkey_0:
        MOVW     R1,#+1317
        MOV      R0,R4
        BL       USART_GetFlagStatus
        CMP      R0,#+0
        BEQ.N    ??getkey_0
//   44 
//   45   return USART_ReceiveData(USARTx);
        MOV      R0,R4
        POP      {R4,LR}
        B.W      USART_ReceiveData
//   46 }

        SECTION `.text`:CODE:NOROOT(2)
        DATA
??DataTable1:
        DC32     0x40013800

        END
// 
// 86 bytes in section .text
// 
// 86 bytes of CODE memory
//
//Errors: none
//Warnings: none
