///////////////////////////////////////////////////////////////////////////////
//                                                                            /
// IAR ANSI C/C++ Compiler V5.40.0.51500/W32 for ARM    07/Sep/2009  17:30:46 /
// Copyright (C) 1999-2009 IAR Systems AB.                                    /
//                                                                            /
//    Cpu mode     =  thumb                                                   /
//    Endian       =  little                                                  /
//    Source file  =  C:\My_App\Libraries\STM32F10x_StdPeriph_Driver\src\stm3 /
//                    2f10x_gpio.c                                            /
//    Command line =  C:\My_App\Libraries\STM32F10x_StdPeriph_Driver\src\stm3 /
//                    2f10x_gpio.c -D USE_STDPERIPH_DRIVER -D STM32F10X_HD    /
//                    -D USE_STM3210E_EVAL -lCN C:\My_App\Project\Template\EW /
//                    ARMv5\STM3210E-EVAL\List\ -lB                           /
//                    C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\List\  /
//                    -o C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\Obj /
//                    \ --debug --endian=little --cpu=Cortex-M3 -e            /
//                    --fpu=None --dlib_config "C:\Program Files\IAR          /
//                    Systems\Embedded Workbench                              /
//                    5.4\arm\INC\DLib_Config_Full.h" -I                      /
//                    C:\My_App\Project\Template\EWARMv5\..\ -I               /
//                    C:\My_App\Project\Template\EWARMv5\..\..\..\Libraries\C /
//                    MSIS\Core\CM3\ -I C:\My_App\Project\Template\EWARMv5\.. /
//                    \..\..\Libraries\STM32F10x_StdPeriph_Driver\inc\ -I     /
//                    "C:\Program Files\IAR Systems\Embedded Workbench        /
//                    5.4\arm\INC\" -Ohz                                      /
//    List file    =  C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\List\s /
//                    tm32f10x_gpio.s                                         /
//                                                                            /
//                                                                            /
///////////////////////////////////////////////////////////////////////////////

        NAME stm32f10x_gpio

        EXTERN RCC_APB2PeriphResetCmd

        PUBLIC GPIO_AFIODeInit
        PUBLIC GPIO_DeInit
        PUBLIC GPIO_EXTILineConfig
        PUBLIC GPIO_EventOutputCmd
        PUBLIC GPIO_EventOutputConfig
        PUBLIC GPIO_Init
        PUBLIC GPIO_PinLockConfig
        PUBLIC GPIO_PinRemapConfig
        PUBLIC GPIO_ReadInputData
        PUBLIC GPIO_ReadInputDataBit
        PUBLIC GPIO_ReadOutputData
        PUBLIC GPIO_ReadOutputDataBit
        PUBLIC GPIO_ResetBits
        PUBLIC GPIO_SetBits
        PUBLIC GPIO_StructInit
        PUBLIC GPIO_Write
        PUBLIC GPIO_WriteBit

// C:\My_App\Libraries\STM32F10x_StdPeriph_Driver\src\stm32f10x_gpio.c
//    1 /**
//    2   ******************************************************************************
//    3   * @file  stm32f10x_gpio.c
//    4   * @author  MCD Application Team
//    5   * @version  V3.0.0
//    6   * @date  04/06/2009
//    7   * @brief  This file provides all the GPIO firmware functions.
//    8   ******************************************************************************
//    9   * @copy
//   10   *
//   11   * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
//   12   * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
//   13   * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
//   14   * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//   15   * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
//   16   * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
//   17   *
//   18   * <h2><center>&copy; COPYRIGHT 2009 STMicroelectronics</center></h2>
//   19   */ 
//   20 
//   21 /* Includes ------------------------------------------------------------------*/
//   22 #include "stm32f10x_gpio.h"
//   23 #include "stm32f10x_rcc.h"
//   24 
//   25 /** @addtogroup StdPeriph_Driver
//   26   * @{
//   27   */
//   28 
//   29 /** @defgroup GPIO 
//   30   * @brief GPIO driver modules
//   31   * @{
//   32   */ 
//   33 
//   34 /** @defgroup GPIO_Private_TypesDefinitions
//   35   * @{
//   36   */
//   37 
//   38 /**
//   39   * @}
//   40   */
//   41 
//   42 /** @defgroup GPIO_Private_Defines
//   43   * @{
//   44   */
//   45 
//   46 /* ------------ RCC registers bit address in the alias region ----------------*/
//   47 #define AFIO_OFFSET                 (AFIO_BASE - PERIPH_BASE)
//   48 
//   49 /* --- EVENTCR Register -----*/
//   50 
//   51 /* Alias word address of EVOE bit */
//   52 #define EVCR_OFFSET                 (AFIO_OFFSET + 0x00)
//   53 #define EVOE_BitNumber              ((uint8_t)0x07)
//   54 #define EVCR_EVOE_BB                (PERIPH_BB_BASE + (EVCR_OFFSET * 32) + (EVOE_BitNumber * 4))
//   55 #define EVCR_PORTPINCONFIG_MASK     ((uint16_t)0xFF80)
//   56 #define LSB_MASK                    ((uint16_t)0xFFFF)
//   57 #define DBGAFR_POSITION_MASK        ((uint32_t)0x000F0000)
//   58 #define DBGAFR_SWJCFG_MASK          ((uint32_t)0xF0FFFFFF)
//   59 #define DBGAFR_LOCATION_MASK        ((uint32_t)0x00200000)
//   60 #define DBGAFR_NUMBITS_MASK         ((uint32_t)0x00100000)
//   61 
//   62 /**
//   63   * @}
//   64   */
//   65 
//   66 /** @defgroup GPIO_Private_Macros
//   67   * @{
//   68   */
//   69 
//   70 /**
//   71   * @}
//   72   */
//   73 
//   74 /** @defgroup GPIO_Private_Variables
//   75   * @{
//   76   */
//   77 
//   78 /**
//   79   * @}
//   80   */
//   81 
//   82 /** @defgroup GPIO_Private_FunctionPrototypes
//   83   * @{
//   84   */
//   85 
//   86 /**
//   87   * @}
//   88   */
//   89 
//   90 /** @defgroup GPIO_Private_Functions
//   91   * @{
//   92   */
//   93 
//   94 /**
//   95   * @brief  Deinitializes the GPIOx peripheral registers to their default
//   96   *   reset values.
//   97   * @param GPIOx: where x can be (A..G) to select the GPIO peripheral.
//   98   * @retval : None
//   99   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  100 void GPIO_DeInit(GPIO_TypeDef* GPIOx)
//  101 {
GPIO_DeInit:
        PUSH     {R7,LR}
//  102   /* Check the parameters */
//  103   assert_param(IS_GPIO_ALL_PERIPH(GPIOx));
//  104   
//  105   switch (*(uint32_t*)&GPIOx)
        LDR.N    R1,??GPIO_DeInit_0  ;; 0x40010800
        SUBS     R0,R0,R1
        BEQ.N    ??GPIO_DeInit_1
        MOV      R1,#+1024
        SUBS     R0,R0,R1
        BEQ.N    ??GPIO_DeInit_2
        SUBS     R0,R0,R1
        BEQ.N    ??GPIO_DeInit_3
        SUBS     R0,R0,R1
        BEQ.N    ??GPIO_DeInit_4
        SUBS     R0,R0,R1
        BEQ.N    ??GPIO_DeInit_5
        SUBS     R0,R0,R1
        BEQ.N    ??GPIO_DeInit_6
        SUBS     R0,R0,R1
        BEQ.N    ??GPIO_DeInit_7
        POP      {R0,PC}
//  106   {
//  107     case GPIOA_BASE:
//  108       RCC_APB2PeriphResetCmd(RCC_APB2Periph_GPIOA, ENABLE);
??GPIO_DeInit_1:
        MOVS     R1,#+1
        MOVS     R0,#+4
        BL       RCC_APB2PeriphResetCmd
//  109       RCC_APB2PeriphResetCmd(RCC_APB2Periph_GPIOA, DISABLE);
        MOVS     R1,#+0
        MOVS     R0,#+4
        B.N      ??GPIO_DeInit_8
//  110       break;
//  111     case GPIOB_BASE:
//  112       RCC_APB2PeriphResetCmd(RCC_APB2Periph_GPIOB, ENABLE);
??GPIO_DeInit_2:
        MOVS     R1,#+1
        MOVS     R0,#+8
        BL       RCC_APB2PeriphResetCmd
//  113       RCC_APB2PeriphResetCmd(RCC_APB2Periph_GPIOB, DISABLE);
        MOVS     R1,#+0
        MOVS     R0,#+8
        B.N      ??GPIO_DeInit_8
//  114       break;
//  115     case GPIOC_BASE:
//  116       RCC_APB2PeriphResetCmd(RCC_APB2Periph_GPIOC, ENABLE);
??GPIO_DeInit_3:
        MOVS     R1,#+1
        MOVS     R0,#+16
        BL       RCC_APB2PeriphResetCmd
//  117       RCC_APB2PeriphResetCmd(RCC_APB2Periph_GPIOC, DISABLE);
        MOVS     R1,#+0
        MOVS     R0,#+16
        B.N      ??GPIO_DeInit_8
//  118       break;
//  119     case GPIOD_BASE:
//  120       RCC_APB2PeriphResetCmd(RCC_APB2Periph_GPIOD, ENABLE);
??GPIO_DeInit_4:
        MOVS     R1,#+1
        MOVS     R0,#+32
        BL       RCC_APB2PeriphResetCmd
//  121       RCC_APB2PeriphResetCmd(RCC_APB2Periph_GPIOD, DISABLE);
        MOVS     R1,#+0
        MOVS     R0,#+32
        B.N      ??GPIO_DeInit_8
//  122       break;
//  123       
//  124     case GPIOE_BASE:
//  125       RCC_APB2PeriphResetCmd(RCC_APB2Periph_GPIOE, ENABLE);
??GPIO_DeInit_5:
        MOVS     R1,#+1
        MOVS     R0,#+64
        BL       RCC_APB2PeriphResetCmd
//  126       RCC_APB2PeriphResetCmd(RCC_APB2Periph_GPIOE, DISABLE);
        MOVS     R1,#+0
        MOVS     R0,#+64
        B.N      ??GPIO_DeInit_8
//  127       break; 
//  128     case GPIOF_BASE:
//  129       RCC_APB2PeriphResetCmd(RCC_APB2Periph_GPIOF, ENABLE);
??GPIO_DeInit_6:
        MOVS     R1,#+1
        MOVS     R0,#+128
        BL       RCC_APB2PeriphResetCmd
//  130       RCC_APB2PeriphResetCmd(RCC_APB2Periph_GPIOF, DISABLE);
        MOVS     R1,#+0
        MOVS     R0,#+128
        B.N      ??GPIO_DeInit_8
//  131       break;
//  132     case GPIOG_BASE:
//  133       RCC_APB2PeriphResetCmd(RCC_APB2Periph_GPIOG, ENABLE);
??GPIO_DeInit_7:
        MOVS     R1,#+1
        MOV      R0,#+256
        BL       RCC_APB2PeriphResetCmd
//  134       RCC_APB2PeriphResetCmd(RCC_APB2Periph_GPIOG, DISABLE);
        MOVS     R1,#+0
        MOV      R0,#+256
//  135       break;
//  136     default:
//  137       break;
//  138   }
??GPIO_DeInit_8:
        B.N      ?Subroutine0
        DATA
??GPIO_DeInit_0:
        DC32     0x40010800
//  139 }
//  140 
//  141 /**
//  142   * @brief  Deinitializes the Alternate Functions (remap, event control
//  143   *   and EXTI configuration) registers to their default reset
//  144   *   values.
//  145   * @param  None
//  146   * @retval : None
//  147   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  148 void GPIO_AFIODeInit(void)
//  149 {
GPIO_AFIODeInit:
        PUSH     {R7,LR}
//  150   RCC_APB2PeriphResetCmd(RCC_APB2Periph_AFIO, ENABLE);
        MOVS     R1,#+1
        MOVS     R0,#+1
        BL       RCC_APB2PeriphResetCmd
//  151   RCC_APB2PeriphResetCmd(RCC_APB2Periph_AFIO, DISABLE);
        MOVS     R1,#+0
        MOVS     R0,#+1
        REQUIRE ?Subroutine0
        ;; // Fall through to label ?Subroutine0
//  152 }

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
?Subroutine0:
        POP      {R2,LR}
        B.W      RCC_APB2PeriphResetCmd
//  153 
//  154 /**
//  155   * @brief  Initializes the GPIOx peripheral according to the specified
//  156   *   parameters in the GPIO_InitStruct.
//  157   * @param GPIOx: where x can be (A..G) to select the GPIO peripheral.
//  158   * @param GPIO_InitStruct: pointer to a GPIO_InitTypeDef structure that
//  159   *   contains the configuration information for the specified GPIO
//  160   *   peripheral.
//  161   * @retval : None
//  162   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  163 void GPIO_Init(GPIO_TypeDef* GPIOx, GPIO_InitTypeDef* GPIO_InitStruct)
//  164 {
GPIO_Init:
        PUSH     {R4-R8,LR}
//  165   uint32_t currentmode = 0x00, currentpin = 0x00, pinpos = 0x00, pos = 0x00;
//  166   uint32_t tmpreg = 0x00, pinmask = 0x00;
//  167   /* Check the parameters */
//  168   assert_param(IS_GPIO_ALL_PERIPH(GPIOx));
//  169   assert_param(IS_GPIO_MODE(GPIO_InitStruct->GPIO_Mode));
//  170   assert_param(IS_GPIO_PIN(GPIO_InitStruct->GPIO_Pin));  
//  171   
//  172 /*---------------------------- GPIO Mode Configuration -----------------------*/
//  173   currentmode = ((uint32_t)GPIO_InitStruct->GPIO_Mode) & ((uint32_t)0x0F);
        LDRB     R3,[R1, #+3]
        AND      R2,R3,#0xF
//  174   if ((((uint32_t)GPIO_InitStruct->GPIO_Mode) & ((uint32_t)0x10)) != 0x00)
        LSLS     R3,R3,#+27
        BPL.N    ??GPIO_Init_0
//  175   { 
//  176     /* Check the parameters */
//  177     assert_param(IS_GPIO_SPEED(GPIO_InitStruct->GPIO_Speed));
//  178     /* Output mode */
//  179     currentmode |= (uint32_t)GPIO_InitStruct->GPIO_Speed;
        LDRB     R3,[R1, #+2]
        ORRS     R2,R3,R2
//  180   }
//  181 /*---------------------------- GPIO CRL Configuration ------------------------*/
//  182   /* Configure the eight low port pins */
//  183   if (((uint32_t)GPIO_InitStruct->GPIO_Pin & ((uint32_t)0x00FF)) != 0x00)
??GPIO_Init_0:
        LDRH     R3,[R1, #+0]
        MOVS     R4,#+1
        MOVS     R5,#+15
        UXTB     R6,R3
        CBZ      R6,??GPIO_Init_1
//  184   {
//  185     tmpreg = GPIOx->CRL;
        LDR      R12,[R0, #+0]
//  186     for (pinpos = 0x00; pinpos < 0x08; pinpos++)
        MOVS     R6,#+0
//  187     {
//  188       pos = ((uint32_t)0x01) << pinpos;
??GPIO_Init_2:
        LSL      R7,R4,R6
//  189       /* Get the port pins position */
//  190       currentpin = (GPIO_InitStruct->GPIO_Pin) & pos;
//  191       if (currentpin == pos)
        AND      R8,R7,R3
        CMP      R8,R7
        BNE.N    ??GPIO_Init_3
//  192       {
//  193         pos = pinpos << 2;
        LSL      LR,R6,#+2
//  194         /* Clear the corresponding low control register bits */
//  195         pinmask = ((uint32_t)0x0F) << pos;
//  196         tmpreg &= ~pinmask;
//  197         /* Write the mode configuration in the corresponding bits */
//  198         tmpreg |= (currentmode << pos);
        LSL      R8,R5,LR
        BIC      R12,R12,R8
        LSL      LR,R2,LR
        ORR      R12,LR,R12
//  199         /* Reset the corresponding ODR bit */
//  200         if (GPIO_InitStruct->GPIO_Mode == GPIO_Mode_IPD)
        LDRB     LR,[R1, #+3]
        CMP      LR,#+40
        BNE.N    ??GPIO_Init_4
//  201         {
//  202           GPIOx->BRR = (((uint32_t)0x01) << pinpos);
        STR      R7,[R0, #+20]
        B.N      ??GPIO_Init_3
//  203         }
//  204         else
//  205         {
//  206           /* Set the corresponding ODR bit */
//  207           if (GPIO_InitStruct->GPIO_Mode == GPIO_Mode_IPU)
??GPIO_Init_4:
        CMP      LR,#+72
        BNE.N    ??GPIO_Init_3
//  208           {
//  209             GPIOx->BSRR = (((uint32_t)0x01) << pinpos);
        STR      R7,[R0, #+16]
//  210           }
//  211         }
//  212       }
//  213     }
??GPIO_Init_3:
        ADDS     R6,R6,#+1
        CMP      R6,#+8
        BCC.N    ??GPIO_Init_2
//  214     GPIOx->CRL = tmpreg;
        STR      R12,[R0, #+0]
//  215   }
//  216 /*---------------------------- GPIO CRH Configuration ------------------------*/
//  217   /* Configure the eight high port pins */
//  218   if (GPIO_InitStruct->GPIO_Pin > 0x00FF)
??GPIO_Init_1:
        MOV      R6,#+256
        CMP      R3,R6
        BCC.N    ??GPIO_Init_5
//  219   {
//  220     tmpreg = GPIOx->CRH;
        LDR      R12,[R0, #+4]
//  221     for (pinpos = 0x00; pinpos < 0x08; pinpos++)
        MOVS     R6,#+0
//  222     {
//  223       pos = (((uint32_t)0x01) << (pinpos + 0x08));
??GPIO_Init_6:
        ADD      R7,R6,#+8
        LSL      R7,R4,R7
//  224       /* Get the port pins position */
//  225       currentpin = ((GPIO_InitStruct->GPIO_Pin) & pos);
//  226       if (currentpin == pos)
        AND      R8,R7,R3
        CMP      R8,R7
        BNE.N    ??GPIO_Init_7
//  227       {
//  228         pos = pinpos << 2;
        LSL      LR,R6,#+2
//  229         /* Clear the corresponding high control register bits */
//  230         pinmask = ((uint32_t)0x0F) << pos;
//  231         tmpreg &= ~pinmask;
//  232         /* Write the mode configuration in the corresponding bits */
//  233         tmpreg |= (currentmode << pos);
        LSL      R8,R5,LR
        BIC      R12,R12,R8
        LSL      LR,R2,LR
        ORR      R12,LR,R12
//  234         /* Reset the corresponding ODR bit */
//  235         if (GPIO_InitStruct->GPIO_Mode == GPIO_Mode_IPD)
        LDRB     LR,[R1, #+3]
        CMP      LR,#+40
        BNE.N    ??GPIO_Init_8
//  236         {
//  237           GPIOx->BRR = (((uint32_t)0x01) << (pinpos + 0x08));
        STR      R7,[R0, #+20]
//  238         }
//  239         /* Set the corresponding ODR bit */
//  240         if (GPIO_InitStruct->GPIO_Mode == GPIO_Mode_IPU)
??GPIO_Init_8:
        LDRB     LR,[R1, #+3]
        CMP      LR,#+72
        BNE.N    ??GPIO_Init_7
//  241         {
//  242           GPIOx->BSRR = (((uint32_t)0x01) << (pinpos + 0x08));
        STR      R7,[R0, #+16]
//  243         }
//  244       }
//  245     }
??GPIO_Init_7:
        ADDS     R6,R6,#+1
        CMP      R6,#+8
        BCC.N    ??GPIO_Init_6
//  246     GPIOx->CRH = tmpreg;
        STR      R12,[R0, #+4]
//  247   }
//  248 }
??GPIO_Init_5:
        POP      {R4-R8,PC}       ;; return
//  249 
//  250 /**
//  251   * @brief  Fills each GPIO_InitStruct member with its default value.
//  252   * @param GPIO_InitStruct : pointer to a GPIO_InitTypeDef structure
//  253   *   which will be initialized.
//  254   * @retval : None
//  255   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  256 void GPIO_StructInit(GPIO_InitTypeDef* GPIO_InitStruct)
//  257 {
//  258   /* Reset GPIO init structure parameters values */
//  259   GPIO_InitStruct->GPIO_Pin  = GPIO_Pin_All;
GPIO_StructInit:
        MOVW     R1,#+65535
        STRH     R1,[R0, #+0]
//  260   GPIO_InitStruct->GPIO_Speed = GPIO_Speed_2MHz;
        MOVS     R1,#+2
        STRB     R1,[R0, #+2]
//  261   GPIO_InitStruct->GPIO_Mode = GPIO_Mode_IN_FLOATING;
        MOVS     R1,#+4
        STRB     R1,[R0, #+3]
//  262 }
        BX       LR               ;; return
//  263 
//  264 /**
//  265   * @brief  Reads the specified input port pin.
//  266   * @param GPIOx: where x can be (A..G) to select the GPIO peripheral.
//  267   * @param GPIO_Pin:  specifies the port bit to read.
//  268   *   This parameter can be GPIO_Pin_x where x can be (0..15).
//  269   * @retval : The input port pin value.
//  270   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  271 uint8_t GPIO_ReadInputDataBit(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin)
//  272 {
//  273   uint8_t bitstatus = 0x00;
//  274   
//  275   /* Check the parameters */
//  276   assert_param(IS_GPIO_ALL_PERIPH(GPIOx));
//  277   assert_param(IS_GET_GPIO_PIN(GPIO_Pin)); 
//  278   
//  279   if ((GPIOx->IDR & GPIO_Pin) != (uint32_t)Bit_RESET)
GPIO_ReadInputDataBit:
        LDR      R0,[R0, #+8]
        B.N      ?Subroutine1
//  280   {
//  281     bitstatus = (uint8_t)Bit_SET;
//  282   }
//  283   else
//  284   {
//  285     bitstatus = (uint8_t)Bit_RESET;
//  286   }
//  287   return bitstatus;
//  288 }
//  289 
//  290 /**
//  291   * @brief  Reads the specified GPIO input data port.
//  292   * @param GPIOx: where x can be (A..G) to select the GPIO peripheral.
//  293   * @retval : GPIO input data port value.
//  294   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  295 uint16_t GPIO_ReadInputData(GPIO_TypeDef* GPIOx)
//  296 {
//  297   /* Check the parameters */
//  298   assert_param(IS_GPIO_ALL_PERIPH(GPIOx));
//  299   
//  300   return ((uint16_t)GPIOx->IDR);
GPIO_ReadInputData:
        LDR      R0,[R0, #+8]
        UXTH     R0,R0
        BX       LR               ;; return
//  301 }
//  302 
//  303 /**
//  304   * @brief  Reads the specified output data port bit.
//  305   * @param GPIOx: where x can be (A..G) to select the GPIO peripheral.
//  306   * @param GPIO_Pin:  specifies the port bit to read.
//  307   *   This parameter can be GPIO_Pin_x where x can be (0..15).
//  308   * @retval : The output port pin value.
//  309   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  310 uint8_t GPIO_ReadOutputDataBit(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin)
//  311 {
//  312   uint8_t bitstatus = 0x00;
//  313   /* Check the parameters */
//  314   assert_param(IS_GPIO_ALL_PERIPH(GPIOx));
//  315   assert_param(IS_GET_GPIO_PIN(GPIO_Pin)); 
//  316   
//  317   if ((GPIOx->ODR & GPIO_Pin) != (uint32_t)Bit_RESET)
GPIO_ReadOutputDataBit:
        LDR      R0,[R0, #+12]
        REQUIRE ?Subroutine1
        ;; // Fall through to label ?Subroutine1
//  318   {
//  319     bitstatus = (uint8_t)Bit_SET;
//  320   }
//  321   else
//  322   {
//  323     bitstatus = (uint8_t)Bit_RESET;
//  324   }
//  325   return bitstatus;
//  326 }

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
?Subroutine1:
        ANDS     R1,R1,R0
        MOVS     R0,R1
        BEQ.N    ??Subroutine1_0
        MOVS     R0,#+1
??Subroutine1_0:
        UXTB     R0,R0
        BX       LR               ;; return
//  327 
//  328 /**
//  329   * @brief  Reads the specified GPIO output data port.
//  330   * @param GPIOx: where x can be (A..G) to select the GPIO peripheral.
//  331   * @retval : GPIO output data port value.
//  332   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  333 uint16_t GPIO_ReadOutputData(GPIO_TypeDef* GPIOx)
//  334 {
//  335   /* Check the parameters */
//  336   assert_param(IS_GPIO_ALL_PERIPH(GPIOx));
//  337     
//  338   return ((uint16_t)GPIOx->ODR);
GPIO_ReadOutputData:
        LDR      R0,[R0, #+12]
        UXTH     R0,R0
        BX       LR               ;; return
//  339 }
//  340 
//  341 /**
//  342   * @brief  Sets the selected data port bits.
//  343   * @param GPIOx: where x can be (A..G) to select the GPIO peripheral.
//  344   * @param GPIO_Pin: specifies the port bits to be written.
//  345   *   This parameter can be any combination of GPIO_Pin_x where 
//  346   *   x can be (0..15).
//  347   * @retval : None
//  348   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  349 void GPIO_SetBits(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin)
//  350 {
//  351   /* Check the parameters */
//  352   assert_param(IS_GPIO_ALL_PERIPH(GPIOx));
//  353   assert_param(IS_GPIO_PIN(GPIO_Pin));
//  354   
//  355   GPIOx->BSRR = GPIO_Pin;
GPIO_SetBits:
        STR      R1,[R0, #+16]
//  356 }
        BX       LR               ;; return
//  357 
//  358 /**
//  359   * @brief  Clears the selected data port bits.
//  360   * @param GPIOx: where x can be (A..G) to select the GPIO peripheral.
//  361   * @param GPIO_Pin: specifies the port bits to be written.
//  362   *   This parameter can be any combination of GPIO_Pin_x where 
//  363   *   x can be (0..15).
//  364   * @retval : None
//  365   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  366 void GPIO_ResetBits(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin)
//  367 {
//  368   /* Check the parameters */
//  369   assert_param(IS_GPIO_ALL_PERIPH(GPIOx));
//  370   assert_param(IS_GPIO_PIN(GPIO_Pin));
//  371   
//  372   GPIOx->BRR = GPIO_Pin;
GPIO_ResetBits:
        STR      R1,[R0, #+20]
//  373 }
        BX       LR               ;; return
//  374 
//  375 /**
//  376   * @brief  Sets or clears the selected data port bit.
//  377   * @param GPIOx: where x can be (A..G) to select the GPIO peripheral.
//  378   * @param GPIO_Pin: specifies the port bit to be written.
//  379   *   This parameter can be one of GPIO_Pin_x where x can be (0..15).
//  380   * @param BitVal: specifies the value to be written to the selected bit.
//  381   *   This parameter can be one of the BitAction enum values:
//  382   * @arg Bit_RESET: to clear the port pin
//  383   * @arg Bit_SET: to set the port pin
//  384   * @retval : None
//  385   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  386 void GPIO_WriteBit(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin, BitAction BitVal)
//  387 {
//  388   /* Check the parameters */
//  389   assert_param(IS_GPIO_ALL_PERIPH(GPIOx));
//  390   assert_param(IS_GET_GPIO_PIN(GPIO_Pin));
//  391   assert_param(IS_GPIO_BIT_ACTION(BitVal)); 
//  392   
//  393   if (BitVal != Bit_RESET)
GPIO_WriteBit:
        CMP      R2,#+0
        ITE      NE 
        STRNE    R1,[R0, #+16]
        STREQ    R1,[R0, #+20]
//  394   {
//  395     GPIOx->BSRR = GPIO_Pin;
        BX       LR
//  396   }
//  397   else
//  398   {
//  399     GPIOx->BRR = GPIO_Pin;
//  400   }
//  401 }
//  402 
//  403 /**
//  404   * @brief  Writes data to the specified GPIO data port.
//  405   * @param GPIOx: where x can be (A..G) to select the GPIO peripheral.
//  406   * @param PortVal: specifies the value to be written to the port output
//  407   *   data register.
//  408   * @retval : None
//  409   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  410 void GPIO_Write(GPIO_TypeDef* GPIOx, uint16_t PortVal)
//  411 {
//  412   /* Check the parameters */
//  413   assert_param(IS_GPIO_ALL_PERIPH(GPIOx));
//  414   
//  415   GPIOx->ODR = PortVal;
GPIO_Write:
        STR      R1,[R0, #+12]
//  416 }
        BX       LR               ;; return
//  417 
//  418 /**
//  419   * @brief  Locks GPIO Pins configuration registers.
//  420   * @param GPIOx: where x can be (A..G) to select the GPIO peripheral.
//  421   * @param GPIO_Pin: specifies the port bit to be written.
//  422   *   This parameter can be any combination of GPIO_Pin_x where 
//  423   *   x can be (0..15).
//  424   * @retval : None
//  425   */

        SECTION `.text`:CODE:NOROOT(1)
        THUMB
//  426 void GPIO_PinLockConfig(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin)
//  427 {
//  428   uint32_t tmp = 0x00010000;
//  429   
//  430   /* Check the parameters */
//  431   assert_param(IS_GPIO_ALL_PERIPH(GPIOx));
//  432   assert_param(IS_GPIO_PIN(GPIO_Pin));
//  433   
//  434   tmp |= GPIO_Pin;
GPIO_PinLockConfig:
        ORR      R2,R1,#0x10000
//  435   /* Set LCKK bit */
//  436   GPIOx->LCKR = tmp;
        STR      R2,[R0, #+24]
//  437   /* Reset LCKK bit */
//  438   GPIOx->LCKR =  GPIO_Pin;
        STR      R1,[R0, #+24]
//  439   /* Set LCKK bit */
//  440   GPIOx->LCKR = tmp;
        STR      R2,[R0, #+24]
//  441   /* Read LCKK bit*/
//  442   tmp = GPIOx->LCKR;
        LDR      R1,[R0, #+24]
//  443   /* Read LCKK bit*/
//  444   tmp = GPIOx->LCKR;
        LDR      R0,[R0, #+24]
//  445 }
        BX       LR               ;; return
//  446 
//  447 /**
//  448   * @brief  Selects the GPIO pin used as Event output.
//  449   * @param GPIO_PortSource: selects the GPIO port to be used as source
//  450   *   for Event output.
//  451   *   This parameter can be GPIO_PortSourceGPIOx where x can be
//  452   *   (A..E).
//  453   * @param GPIO_PinSource: specifies the pin for the Event output.
//  454   *   This parameter can be GPIO_PinSourcex where x can be (0..15).
//  455   * @retval : None
//  456   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  457 void GPIO_EventOutputConfig(uint8_t GPIO_PortSource, uint8_t GPIO_PinSource)
//  458 {
GPIO_EventOutputConfig:
        PUSH     {R4,LR}
//  459   uint32_t tmpreg = 0x00;
//  460   /* Check the parameters */
//  461   assert_param(IS_GPIO_EVENTOUT_PORT_SOURCE(GPIO_PortSource));
//  462   assert_param(IS_GPIO_PIN_SOURCE(GPIO_PinSource));
//  463     
//  464   tmpreg = AFIO->EVCR;
        LDR.N    R2,??GPIO_EventOutputConfig_0  ;; 0x40010000
        LDR      R3,[R2, #+0]
//  465   /* Clear the PORT[6:4] and PIN[3:0] bits */
//  466   tmpreg &= EVCR_PORTPINCONFIG_MASK;
//  467   tmpreg |= (uint32_t)GPIO_PortSource << 0x04;
//  468   tmpreg |= GPIO_PinSource;
//  469   AFIO->EVCR = tmpreg;
        MOVW     R4,#+65408
        ANDS     R3,R4,R3
        ORR      R0,R3,R0, LSL #+4
        ORRS     R0,R1,R0
        STR      R0,[R2, #+0]
//  470 }
        POP      {R4,PC}          ;; return
        Nop      
        DATA
??GPIO_EventOutputConfig_0:
        DC32     0x40010000
//  471 
//  472 /**
//  473   * @brief  Enables or disables the Event Output.
//  474   * @param NewState: new state of the Event output.
//  475   *   This parameter can be: ENABLE or DISABLE.
//  476   * @retval : None
//  477   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  478 void GPIO_EventOutputCmd(FunctionalState NewState)
//  479 {
//  480   /* Check the parameters */
//  481   assert_param(IS_FUNCTIONAL_STATE(NewState));
//  482   
//  483   *(__IO uint32_t *) EVCR_EVOE_BB = (uint32_t)NewState;
GPIO_EventOutputCmd:
        LDR.N    R1,??GPIO_EventOutputCmd_0  ;; 0x4220001c
        STR      R0,[R1, #+0]
//  484 }
        BX       LR               ;; return
        Nop      
        DATA
??GPIO_EventOutputCmd_0:
        DC32     0x4220001c
//  485 
//  486 /**
//  487   * @brief  Changes the mapping of the specified pin.
//  488   * @param GPIO_Remap: selects the pin to remap.
//  489   *   This parameter can be one of the following values:
//  490   * @arg GPIO_Remap_SPI1
//  491   * @arg GPIO_Remap_I2C1
//  492   * @arg GPIO_Remap_USART1
//  493   * @arg GPIO_Remap_USART2
//  494   * @arg GPIO_PartialRemap_USART3
//  495   * @arg GPIO_FullRemap_USART3
//  496   * @arg GPIO_PartialRemap_TIM1
//  497   * @arg GPIO_FullRemap_TIM1
//  498   * @arg GPIO_PartialRemap1_TIM2
//  499   * @arg GPIO_PartialRemap2_TIM2
//  500   * @arg GPIO_FullRemap_TIM2
//  501   * @arg GPIO_PartialRemap_TIM3
//  502   * @arg GPIO_FullRemap_TIM3
//  503   * @arg GPIO_Remap_TIM4
//  504   * @arg GPIO_Remap1_CAN1
//  505   * @arg GPIO_Remap2_CAN1
//  506   * @arg GPIO_Remap_PD01
//  507   * @arg GPIO_Remap_TIM5CH4_LSI
//  508   * @arg GPIO_Remap_ADC1_ETRGINJ
//  509   * @arg GPIO_Remap_ADC1_ETRGREG
//  510   * @arg GPIO_Remap_ADC2_ETRGINJ
//  511   * @arg GPIO_Remap_ADC2_ETRGREG
//  512   * @arg GPIO_Remap_SWJ_NoJTRST
//  513   * @arg GPIO_Remap_SWJ_JTAGDisable
//  514   * @arg GPIO_Remap_SWJ_Disable
//  515   * @param NewState: new state of the port pin remapping.
//  516   *   This parameter can be: ENABLE or DISABLE.
//  517   * @retval : None
//  518   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  519 void GPIO_PinRemapConfig(uint32_t GPIO_Remap, FunctionalState NewState)
//  520 {
GPIO_PinRemapConfig:
        PUSH     {R4-R6,LR}
//  521   uint32_t tmp = 0x00, tmp1 = 0x00, tmpreg = 0x00, tmpmask = 0x00;
//  522   /* Check the parameters */
//  523   assert_param(IS_GPIO_REMAP(GPIO_Remap));
//  524   assert_param(IS_FUNCTIONAL_STATE(NewState));  
//  525   
//  526   tmpreg = AFIO->MAPR;
        LDR.N    R2,??GPIO_PinRemapConfig_0  ;; 0x40010004
        LDR      R4,[R2, #+0]
//  527   tmpmask = (GPIO_Remap & DBGAFR_POSITION_MASK) >> 0x10;
        AND      R3,R0,#0xF0000
        LSRS     R5,R3,#+16
//  528   tmp = GPIO_Remap & LSB_MASK;
        UXTH     R3,R0
//  529   if ((GPIO_Remap & (DBGAFR_LOCATION_MASK | DBGAFR_NUMBITS_MASK)) == (DBGAFR_LOCATION_MASK | DBGAFR_NUMBITS_MASK))
        LSRS     R6,R0,#+21
        LSLS     R6,R6,#+4
        LSLS     R3,R3,R6
        AND      R6,R0,#0x300000
        CMP      R6,#+3145728
        BNE.N    ??GPIO_PinRemapConfig_1
//  530   {
//  531     tmpreg &= DBGAFR_SWJCFG_MASK;
        BIC      R0,R4,#0xF000000
//  532     AFIO->MAPR &= DBGAFR_SWJCFG_MASK;
        LDR      R4,[R2, #+0]
        BIC      R4,R4,#0xF000000
        STR      R4,[R2, #+0]
        B.N      ??GPIO_PinRemapConfig_2
//  533   }
//  534   else if ((GPIO_Remap & DBGAFR_NUMBITS_MASK) == DBGAFR_NUMBITS_MASK)
??GPIO_PinRemapConfig_1:
        LSLS     R0,R0,#+11
        ITTTE    MI 
        MOVMI    R0,#+3
        LSLMI    R0,R0,R5
        BICMI    R0,R4,R0
        BICPL    R0,R4,R3
//  535   {
//  536     tmp1 = ((uint32_t)0x03) << tmpmask;
//  537     tmpreg &= ~tmp1;
//  538     tmpreg |= ~DBGAFR_SWJCFG_MASK;
//  539   }
//  540   else
//  541   {
//  542     tmpreg &= ~(tmp << ((GPIO_Remap >> 0x15)*0x10));
//  543     tmpreg |= ~DBGAFR_SWJCFG_MASK;
        ORR      R0,R0,#0xF000000
//  544   }
//  545   if (NewState != DISABLE)
??GPIO_PinRemapConfig_2:
        CBZ      R1,??GPIO_PinRemapConfig_3
//  546   {
//  547     tmpreg |= (tmp << ((GPIO_Remap >> 0x15)*0x10));
        ORRS     R0,R3,R0
//  548   }
//  549   AFIO->MAPR = tmpreg;
??GPIO_PinRemapConfig_3:
        STR      R0,[R2, #+0]
//  550 }
        POP      {R4-R6,PC}       ;; return
        DATA
??GPIO_PinRemapConfig_0:
        DC32     0x40010004
//  551 
//  552 /**
//  553   * @brief  Selects the GPIO pin used as EXTI Line.
//  554   * @param GPIO_PortSource: selects the GPIO port to be used as
//  555   *   source for EXTI lines.
//  556   *   This parameter can be GPIO_PortSourceGPIOx where x can be
//  557   *   (A..G).
//  558   * @param GPIO_PinSource: specifies the EXTI line to be configured.
//  559   *   This parameter can be GPIO_PinSourcex where x can be (0..15).
//  560   * @retval : None
//  561   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  562 void GPIO_EXTILineConfig(uint8_t GPIO_PortSource, uint8_t GPIO_PinSource)
//  563 {
GPIO_EXTILineConfig:
        PUSH     {R4,R5,LR}
//  564   uint32_t tmp = 0x00;
//  565   /* Check the parameters */
//  566   assert_param(IS_GPIO_EXTI_PORT_SOURCE(GPIO_PortSource));
//  567   assert_param(IS_GPIO_PIN_SOURCE(GPIO_PinSource));
//  568   
//  569   tmp = ((uint32_t)0x0F) << (0x04 * (GPIO_PinSource & (uint8_t)0x03));
//  570   AFIO->EXTICR[GPIO_PinSource >> 0x02] &= ~tmp;
        AND      R2,R1,#0x3
        LSLS     R2,R2,#+2
        ASRS     R1,R1,#+2
        LDR.N    R3,??GPIO_EXTILineConfig_0  ;; 0x40010008
        LDR      R4,[R3, R1, LSL #+2]
        MOVS     R5,#+15
        LSLS     R5,R5,R2
        BICS     R4,R4,R5
        STR      R4,[R3, R1, LSL #+2]
//  571   AFIO->EXTICR[GPIO_PinSource >> 0x02] |= (((uint32_t)GPIO_PortSource) << (0x04 * (GPIO_PinSource & (uint8_t)0x03)));
        LDR      R4,[R3, R1, LSL #+2]
        LSLS     R0,R0,R2
        ORRS     R0,R0,R4
        STR      R0,[R3, R1, LSL #+2]
//  572 }
        POP      {R4,R5,PC}       ;; return
        DATA
??GPIO_EXTILineConfig_0:
        DC32     0x40010008

        END
//  573 
//  574 /**
//  575   * @}
//  576   */
//  577 
//  578 /**
//  579   * @}
//  580   */
//  581 
//  582 /**
//  583   * @}
//  584   */
//  585 
//  586 /******************* (C) COPYRIGHT 2009 STMicroelectronics *****END OF FILE****/
// 
// 596 bytes in section .text
// 
// 596 bytes of CODE memory
//
//Errors: none
//Warnings: none
