///////////////////////////////////////////////////////////////////////////////
//                                                                            /
// IAR ANSI C/C++ Compiler V5.40.0.51500/W32 for ARM    07/Sep/2009  17:30:52 /
// Copyright (C) 1999-2009 IAR Systems AB.                                    /
//                                                                            /
//    Cpu mode     =  thumb                                                   /
//    Endian       =  little                                                  /
//    Source file  =  C:\My_App\Libraries\CMSIS\Core\CM3\system_stm32f10x.c   /
//    Command line =  C:\My_App\Libraries\CMSIS\Core\CM3\system_stm32f10x.c   /
//                    -D USE_STDPERIPH_DRIVER -D STM32F10X_HD -D              /
//                    USE_STM3210E_EVAL -lCN C:\My_App\Project\Template\EWARM /
//                    v5\STM3210E-EVAL\List\ -lB                              /
//                    C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\List\  /
//                    -o C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\Obj /
//                    \ --debug --endian=little --cpu=Cortex-M3 -e            /
//                    --fpu=None --dlib_config "C:\Program Files\IAR          /
//                    Systems\Embedded Workbench                              /
//                    5.4\arm\INC\DLib_Config_Full.h" -I                      /
//                    C:\My_App\Project\Template\EWARMv5\..\ -I               /
//                    C:\My_App\Project\Template\EWARMv5\..\..\..\Libraries\C /
//                    MSIS\Core\CM3\ -I C:\My_App\Project\Template\EWARMv5\.. /
//                    \..\..\Libraries\STM32F10x_StdPeriph_Driver\inc\ -I     /
//                    "C:\Program Files\IAR Systems\Embedded Workbench        /
//                    5.4\arm\INC\" -Ohz                                      /
//    List file    =  C:\My_App\Project\Template\EWARMv5\STM3210E-EVAL\List\s /
//                    ystem_stm32f10x.s                                       /
//                                                                            /
//                                                                            /
///////////////////////////////////////////////////////////////////////////////

        NAME system_stm32f10x

        PUBLIC SystemFrequency
        PUBLIC SystemFrequency_AHBClk
        PUBLIC SystemFrequency_APB1Clk
        PUBLIC SystemFrequency_APB2Clk
        PUBLIC SystemFrequency_SysClk
        PUBLIC SystemInit

// C:\My_App\Libraries\CMSIS\Core\CM3\system_stm32f10x.c
//    1 /**
//    2   ******************************************************************************
//    3   * @file system_stm32f10x.c
//    4   * @brief CMSIS Cortex-M3 Device Peripheral Access Layer System Source File.
//    5   * @author STMicroelectronics - MCD Application Team
//    6   * @version V3.0.0
//    7   * @date 04/06/2009
//    8   ******************************************************************************
//    9   *
//   10   * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
//   11   * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
//   12   * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
//   13   * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//   14   * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
//   15   * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
//   16   *
//   17   * <h2><center>&copy; COPYRIGHT 2009 STMicroelectronics</center></h2>
//   18   ******************************************************************************
//   19   */
//   20 
//   21 /** @addtogroup Private_Includes
//   22   * @{
//   23   */
//   24 
//   25 #include "stm32f10x.h"
//   26 
//   27 /**
//   28   * @}
//   29   */
//   30 
//   31 /** @addtogroup Private_TypesDefinitions
//   32   * @{
//   33   */
//   34 
//   35 /**
//   36   * @}
//   37   */
//   38 
//   39 /** @addtogroup Private_Defines
//   40   * @{
//   41   */
//   42 
//   43 /*!< Uncomment the line corresponding to the desired System clock (SYSCLK)
//   44    frequency (after reset the HSI is used as SYSCLK source) */
//   45 //#define SYSCLK_FREQ_HSE    HSE_Value
//   46 //#define SYSCLK_FREQ_20MHz  20000000
//   47 //#define SYSCLK_FREQ_36MHz  36000000
//   48 //#define SYSCLK_FREQ_48MHz  48000000
//   49 //#define SYSCLK_FREQ_56MHz  56000000
//   50 #define SYSCLK_FREQ_72MHz  72000000
//   51 
//   52 /*!< Uncomment the  following line if you need to use external SRAM mounted
//   53      on STM3210E-EVAL board (STM32 High density devices) as data memory  */ 
//   54 #ifdef STM32F10X_HD
//   55 /* #define DATA_IN_ExtSRAM */
//   56 #endif /* STM32F10X_HD */
//   57 
//   58 /**
//   59   * @}
//   60   */
//   61 
//   62 /** @addtogroup Private_Macros
//   63   * @{
//   64   */
//   65 
//   66 /**
//   67   * @}
//   68   */
//   69 
//   70 /** @addtogroup Private_Variables
//   71   * @{
//   72   */
//   73 
//   74 /*******************************************************************************
//   75 *  Clock Definitions
//   76 *******************************************************************************/
//   77 #ifdef SYSCLK_FREQ_HSE
//   78   const uint32_t SystemFrequency         = SYSCLK_FREQ_HSE;        /*!< System Clock Frequency (Core Clock) */
//   79   const uint32_t SystemFrequency_SysClk  = SYSCLK_FREQ_HSE;        /*!< System clock                        */
//   80   const uint32_t SystemFrequency_AHBClk  = SYSCLK_FREQ_HSE;        /*!< AHB System bus speed                */
//   81   const uint32_t SystemFrequency_APB1Clk = SYSCLK_FREQ_HSE;        /*!< APB Peripheral bus 1 (low)  speed   */
//   82   const uint32_t SystemFrequency_APB2Clk = SYSCLK_FREQ_HSE;        /*!< APB Peripheral bus 2 (high) speed   */
//   83 #elif defined SYSCLK_FREQ_20MHz
//   84   const uint32_t SystemFrequency         = SYSCLK_FREQ_20MHz;      /*!< System Clock Frequency (Core Clock) */
//   85   const uint32_t SystemFrequency_SysClk  = SYSCLK_FREQ_20MHz;      /*!< System clock                        */
//   86   const uint32_t SystemFrequency_AHBClk  = SYSCLK_FREQ_20MHz;      /*!< AHB System bus speed                */
//   87   const uint32_t SystemFrequency_APB1Clk = SYSCLK_FREQ_20MHz;      /*!< APB Peripheral bus 1 (low)  speed   */
//   88   const uint32_t SystemFrequency_APB2Clk = SYSCLK_FREQ_20MHz;      /*!< APB Peripheral bus 2 (high) speed   */
//   89 #elif defined SYSCLK_FREQ_36MHz
//   90   const uint32_t SystemFrequency         = SYSCLK_FREQ_36MHz;      /*!< System Clock Frequency (Core Clock) */
//   91   const uint32_t SystemFrequency_SysClk  = SYSCLK_FREQ_36MHz;      /*!< System clock                        */
//   92   const uint32_t SystemFrequency_AHBClk  = SYSCLK_FREQ_36MHz;      /*!< AHB System bus speed                */
//   93   const uint32_t SystemFrequency_APB1Clk = SYSCLK_FREQ_36MHz;      /*!< APB Peripheral bus 1 (low)  speed   */
//   94   const uint32_t SystemFrequency_APB2Clk = SYSCLK_FREQ_36MHz;      /*!< APB Peripheral bus 2 (high) speed   */
//   95 #elif defined SYSCLK_FREQ_48MHz
//   96   const uint32_t SystemFrequency         = SYSCLK_FREQ_48MHz;      /*!< System Clock Frequency (Core Clock) */
//   97   const uint32_t SystemFrequency_SysClk  = SYSCLK_FREQ_48MHz;      /*!< System clock                        */
//   98   const uint32_t SystemFrequency_AHBClk  = SYSCLK_FREQ_48MHz;      /*!< AHB System bus speed                */
//   99   const uint32_t SystemFrequency_APB1Clk = (SYSCLK_FREQ_48MHz/2);  /*!< APB Peripheral bus 1 (low)  speed   */
//  100   const uint32_t SystemFrequency_APB2Clk = SYSCLK_FREQ_48MHz;      /*!< APB Peripheral bus 2 (high) speed   */
//  101 #elif defined SYSCLK_FREQ_56MHz
//  102   const uint32_t SystemFrequency         = SYSCLK_FREQ_56MHz;      /*!< System Clock Frequency (Core Clock) */
//  103   const uint32_t SystemFrequency_SysClk  = SYSCLK_FREQ_56MHz;      /*!< System clock                        */
//  104   const uint32_t SystemFrequency_AHBClk  = SYSCLK_FREQ_56MHz;      /*!< AHB System bus speed                */
//  105   const uint32_t SystemFrequency_APB1Clk = (SYSCLK_FREQ_56MHz/2);  /*!< APB Peripheral bus 1 (low)  speed   */
//  106   const uint32_t SystemFrequency_APB2Clk = SYSCLK_FREQ_56MHz;      /*!< APB Peripheral bus 2 (high) speed   */  
//  107 #elif defined SYSCLK_FREQ_72MHz

        SECTION `.rodata`:CONST:NOROOT(2)
//  108   const uint32_t SystemFrequency         = SYSCLK_FREQ_72MHz;      /*!< System Clock Frequency (Core Clock) */
SystemFrequency:
        DATA
        DC32 72000000

        SECTION `.rodata`:CONST:NOROOT(2)
//  109   const uint32_t SystemFrequency_SysClk  = SYSCLK_FREQ_72MHz;      /*!< System clock                        */
SystemFrequency_SysClk:
        DATA
        DC32 72000000

        SECTION `.rodata`:CONST:NOROOT(2)
//  110   const uint32_t SystemFrequency_AHBClk  = SYSCLK_FREQ_72MHz;      /*!< AHB System bus speed                */
SystemFrequency_AHBClk:
        DATA
        DC32 72000000

        SECTION `.rodata`:CONST:NOROOT(2)
//  111   const uint32_t SystemFrequency_APB1Clk = (SYSCLK_FREQ_72MHz/2);  /*!< APB Peripheral bus 1 (low)  speed   */
SystemFrequency_APB1Clk:
        DATA
        DC32 36000000

        SECTION `.rodata`:CONST:NOROOT(2)
//  112   const uint32_t SystemFrequency_APB2Clk = SYSCLK_FREQ_72MHz;      /*!< APB Peripheral bus 2 (high) speed   */
SystemFrequency_APB2Clk:
        DATA
        DC32 72000000
//  113 #else /*!< HSI Selected as System Clock source */
//  114   const uint32_t SystemFrequency         = HSI_Value;                /*!< System Clock Frequency (Core Clock) */
//  115   const uint32_t SystemFrequency_SysClk  = HSI_Value;                /*!< System clock                        */
//  116   const uint32_t SystemFrequency_AHBClk  = HSI_Value;                /*!< AHB System bus speed                */
//  117   const uint32_t SystemFrequency_APB1Clk = HSI_Value;                /*!< APB Peripheral bus 1 (low)  speed   */
//  118   const uint32_t SystemFrequency_APB2Clk = HSI_Value;                /*!< APB Peripheral bus 2 (high) speed   */
//  119 #endif
//  120 
//  121 /**
//  122   * @}
//  123   */
//  124 
//  125 /** @addtogroup Private_FunctionPrototypes
//  126   * @{
//  127   */
//  128 
//  129 static void SetSysClock(void);
//  130 
//  131 #ifdef SYSCLK_FREQ_HSE
//  132   static void SetSysClockToHSE(void);
//  133 #elif defined SYSCLK_FREQ_20MHz
//  134   static void SetSysClockTo20(void);
//  135 #elif defined SYSCLK_FREQ_36MHz
//  136   static void SetSysClockTo36(void);
//  137 #elif defined SYSCLK_FREQ_48MHz
//  138   static void SetSysClockTo48(void);
//  139 #elif defined SYSCLK_FREQ_56MHz
//  140   static void SetSysClockTo56(void);  
//  141 #elif defined SYSCLK_FREQ_72MHz
//  142   static void SetSysClockTo72(void);
//  143 #endif
//  144 
//  145 /**
//  146   * @}
//  147   */
//  148 
//  149 /** @addtogroup Private_Functions
//  150   * @{
//  151   */
//  152 
//  153 /**
//  154   * @brief Setup the microcontroller system
//  155   *        Initialize the Embedded Flash Interface,  initialize the PLL and update th SystemFrequency variable
//  156   * @param None.
//  157   * @arg None.
//  158   * @note : This function should be used only after reset.
//  159   * @retval value: None.
//  160   */

        SECTION `.text`:CODE:NOROOT(2)
        THUMB
//  161 void SystemInit (void)
//  162 {
SystemInit:
        SUB      SP,SP,#+8
//  163   /*!< RCC system reset(for debug purpose) */
//  164   /*!< Set HSION bit */
//  165   RCC->CR |= (uint32_t)0x00000001;
        LDR.N    R0,??SystemInit_0  ;; 0x40021000
        LDR      R1,[R0, #+0]
        ORR      R1,R1,#0x1
        STR      R1,[R0, #+0]
//  166   /*!< Reset SW[1:0], HPRE[3:0], PPRE1[2:0], PPRE2[2:0], ADCPRE[1:0] and MCO[2:0] bits */
//  167   RCC->CFGR &= (uint32_t)0xF8FF0000;  
        LDR      R1,[R0, #+4]
        LDR.N    R2,??SystemInit_0+0x4  ;; 0xf8ff0000
        ANDS     R1,R2,R1
        STR      R1,[R0, #+4]
//  168   /*!< Reset HSEON, CSSON and PLLON bits */
//  169   RCC->CR &= (uint32_t)0xFEF6FFFF;
        LDR      R1,[R0, #+0]
        LDR.N    R2,??SystemInit_0+0x8  ;; 0xfef6ffff
        ANDS     R1,R2,R1
        STR      R1,[R0, #+0]
//  170   /*!< Reset HSEBYP bit */
//  171   RCC->CR &= (uint32_t)0xFFFBFFFF;
        LDR      R1,[R0, #+0]
        BIC      R1,R1,#0x40000
        STR      R1,[R0, #+0]
//  172   /*!< Reset PLLSRC, PLLXTPRE, PLLMUL[3:0] and USBPRE bits */
//  173   RCC->CFGR &= (uint32_t)0xFF80FFFF;
        LDR      R1,[R0, #+4]
        BIC      R1,R1,#0x7F0000
        STR      R1,[R0, #+4]
//  174   /*!< Disable all interrupts */
//  175   RCC->CIR = 0x00000000;
        MOVS     R1,#+0
        STR      R1,[R0, #+8]
//  176     
//  177   /*!< Configure the System clock frequency, HCLK, PCLK2 and PCLK1 prescalers */
//  178   /*!< Configure the Flash Latency cycles and enable prefetch buffer */
//  179   SetSysClock();
        STR      R1,[SP, #+4]
        STR      R1,[SP, #+0]
        LDR      R1,[R0, #+0]
        ORR      R1,R1,#0x10000
        STR      R1,[R0, #+0]
??SystemInit_1:
        LDR      R1,[R0, #+0]
        AND      R1,R1,#0x20000
        STR      R1,[SP, #+0]
        LDR      R1,[SP, #+4]
        ADDS     R1,R1,#+1
        STR      R1,[SP, #+4]
        LDR      R1,[SP, #+0]
        CBNZ     R1,??SystemInit_2
        LDR      R1,[SP, #+4]
        CMP      R1,#+1280
        BNE.N    ??SystemInit_1
??SystemInit_2:
        LDR      R1,[R0, #+0]
        ANDS     R1,R1,#0x20000
        BEQ.N    ??SystemInit_3
        MOVS     R1,#+1
??SystemInit_3:
        UXTB     R1,R1
        STR      R1,[SP, #+0]
        LDR      R1,[SP, #+0]
        CMP      R1,#+1
        BNE.N    ??SystemInit_4
        LDR.N    R1,??SystemInit_0+0xC  ;; 0x40022000
        LDR      R2,[R1, #+0]
        ORR      R2,R2,#0x10
        STR      R2,[R1, #+0]
        LDR      R2,[R1, #+0]
        LSRS     R2,R2,#+2
        LSLS     R2,R2,#+2
        STR      R2,[R1, #+0]
        LDR      R2,[R1, #+0]
        ORR      R2,R2,#0x2
        STR      R2,[R1, #+0]
        LDR      R1,[R0, #+4]
        STR      R1,[R0, #+4]
        LDR      R1,[R0, #+4]
        STR      R1,[R0, #+4]
        LDR      R1,[R0, #+4]
        ORR      R1,R1,#0x400
        STR      R1,[R0, #+4]
        LDR      R1,[R0, #+4]
        BIC      R1,R1,#0x3F0000
        STR      R1,[R0, #+4]
        LDR      R1,[R0, #+4]
        ORR      R1,R1,#0x1D0000
        STR      R1,[R0, #+4]
        LDR      R1,[R0, #+0]
        ORR      R1,R1,#0x1000000
        STR      R1,[R0, #+0]
??SystemInit_5:
        LDR      R1,[R0, #+0]
        LSLS     R1,R1,#+6
        BPL.N    ??SystemInit_5
        LDR      R1,[R0, #+4]
        LSRS     R1,R1,#+2
        LSLS     R1,R1,#+2
        STR      R1,[R0, #+4]
        LDR      R1,[R0, #+4]
        ORR      R1,R1,#0x2
        STR      R1,[R0, #+4]
??SystemInit_6:
        LDR      R1,[R0, #+4]
        AND      R1,R1,#0xC
        CMP      R1,#+8
        BNE.N    ??SystemInit_6
//  180 
//  181 }
        ADD      SP,SP,#+8
        BX       LR               ;; return
??SystemInit_4:
        B.N      ??SystemInit_4
        Nop      
        DATA
??SystemInit_0:
        DC32     0x40021000
        DC32     0xf8ff0000
        DC32     0xfef6ffff
        DC32     0x40022000

        END
//  182 
//  183 /**
//  184   * @brief Configures the System clock frequency, HCLK, PCLK2 and PCLK1 
//  185   *        prescalers.
//  186   * @param None.
//  187   * @arg None.
//  188   * @note : None.
//  189   * @retval value: None.
//  190   */
//  191 static void SetSysClock(void)
//  192 {
//  193 #ifdef SYSCLK_FREQ_HSE
//  194   SetSysClockToHSE();
//  195 #elif defined SYSCLK_FREQ_20MHz
//  196   SetSysClockTo20();
//  197 #elif defined SYSCLK_FREQ_36MHz
//  198   SetSysClockTo36();
//  199 #elif defined SYSCLK_FREQ_48MHz
//  200   SetSysClockTo48();
//  201 #elif defined SYSCLK_FREQ_56MHz
//  202   SetSysClockTo56();  
//  203 #elif defined SYSCLK_FREQ_72MHz
//  204   SetSysClockTo72();
//  205 #endif
//  206  
//  207  /*!< If none of the define above is enabled, the HSI is used as System clock
//  208     source (default after reset) */ 
//  209 }
//  210 
//  211 /**
//  212   * @brief Setup the external memory controller. Called in startup_stm32f10x.s 
//  213   *        before jump to __main
//  214   * @param None.
//  215   * @arg None.
//  216   * @note : None.
//  217   * @retval value: None.
//  218   */ 
//  219 #ifdef DATA_IN_ExtSRAM
//  220 /**
//  221   * @brief Setup the external memory controller. 
//  222   *        Called in startup_stm32f10x_xx.s/.c before jump to main.
//  223   * 	   This function configures the external SRAM mounted on STM3210E-EVAL
//  224   *      board (STM32 High density devices). This SRAM will be used as program
//  225   *      data memory (including heap and stack).
//  226   * @param None.
//  227   * @arg None.
//  228   * @note : None.
//  229   * @retval value: None.
//  230   */ 
//  231 void SystemInit_ExtMemCtl(void) 
//  232 {
//  233 /*!< FSMC Bank1 NOR/SRAM3 is used for the STM3210E-EVAL, if another Bank is 
//  234   required, then adjust the Register Addresses */
//  235 
//  236   /*!< Enable FSMC clock */
//  237   RCC->AHBENR = 0x00000114;
//  238   
//  239   /*!< Enable GPIOD, GPIOE, GPIOF and GPIOG clocks */  
//  240   RCC->APB2ENR = 0x000001E0;
//  241   
//  242 /* ---------------  SRAM Data lines, NOE and NWE configuration ---------------*/
//  243 /*----------------  SRAM Address lines configuration -------------------------*/
//  244 /*----------------  NOE and NWE configuration --------------------------------*/  
//  245 /*----------------  NE3 configuration ----------------------------------------*/
//  246 /*----------------  NBL0, NBL1 configuration ---------------------------------*/
//  247   
//  248   GPIOD->CRL = 0x44BB44BB;  
//  249   GPIOD->CRH = 0xBBBBBBBB;
//  250 
//  251   GPIOE->CRL = 0xB44444BB;  
//  252   GPIOE->CRH = 0xBBBBBBBB;
//  253 
//  254   GPIOF->CRL = 0x44BBBBBB;  
//  255   GPIOF->CRH = 0xBBBB4444;
//  256 
//  257   GPIOG->CRL = 0x44BBBBBB;  
//  258   GPIOG->CRH = 0x44444B44;
//  259    
//  260 /*----------------  FSMC Configuration ---------------------------------------*/  
//  261 /*----------------  Enable FSMC Bank1_SRAM Bank ------------------------------*/
//  262   
//  263   FSMC_Bank1->BTCR[4] = 0x00001011;
//  264   FSMC_Bank1->BTCR[5] = 0x00000200;
//  265 }
//  266 #endif /* DATA_IN_ExtSRAM */
//  267 
//  268 #ifdef SYSCLK_FREQ_HSE
//  269 /**
//  270   * @brief Selects HSE as System clock source and configure HCLK, PCLK2
//  271   *        and PCLK1 prescalers.
//  272   * @param None.
//  273   * @arg None.
//  274   * @note : This function should be used only after reset.
//  275   * @retval value: None.
//  276   */
//  277 static void SetSysClockToHSE(void)
//  278 {
//  279   __IO uint32_t StartUpCounter = 0, HSEStatus = 0;
//  280   
//  281   /*!< SYSCLK, HCLK, PCLK2 and PCLK1 configuration ---------------------------*/    
//  282   /*!< Enable HSE */    
//  283   RCC->CR |= ((uint32_t)RCC_CR_HSEON);
//  284  
//  285   /*!< Wait till HSE is ready and if Time out is reached exit */
//  286   do
//  287   {
//  288     HSEStatus = RCC->CR & RCC_CR_HSERDY;
//  289     StartUpCounter++;  
//  290   } while((HSEStatus == 0) && (StartUpCounter != HSEStartUp_TimeOut));
//  291 
//  292   if ((RCC->CR & RCC_CR_HSERDY) != RESET)
//  293   {
//  294     HSEStatus = (uint32_t)0x01;
//  295   }
//  296   else
//  297   {
//  298     HSEStatus = (uint32_t)0x00;
//  299   }  
//  300 
//  301   if (HSEStatus == (uint32_t)0x01)
//  302   {
//  303     /*!< Enable Prefetch Buffer */
//  304     FLASH->ACR |= FLASH_ACR_PRFTBE;
//  305 
//  306     /*!< Flash 0 wait state */
//  307     FLASH->ACR &= (uint32_t)((uint32_t)~FLASH_ACR_LATENCY);
//  308     FLASH->ACR |= (uint32_t)FLASH_ACR_LATENCY_0;    
//  309  
//  310     /*!< HCLK = SYSCLK */
//  311     RCC->CFGR |= (uint32_t)RCC_CFGR_HPRE_DIV1;
//  312       
//  313     /*!< PCLK2 = HCLK */
//  314     RCC->CFGR |= (uint32_t)RCC_CFGR_PPRE2_DIV1;
//  315     
//  316     /*!< PCLK1 = HCLK */
//  317     RCC->CFGR |= (uint32_t)RCC_CFGR_PPRE1_DIV1;
//  318     
//  319     /*!< Select HSE as system clock source */
//  320     RCC->CFGR &= (uint32_t)((uint32_t)~(RCC_CFGR_SW));
//  321     RCC->CFGR |= (uint32_t)RCC_CFGR_SW_HSE;    
//  322 
//  323     /*!< Wait till HSE is used as system clock source */
//  324     while ((RCC->CFGR & (uint32_t)RCC_CFGR_SWS) != (uint32_t)0x04)
//  325     {
//  326     }
//  327   }
//  328   else
//  329   { /*!< If HSE fails to start-up, the application will have wrong clock 
//  330          configuration. User can add here some code to deal with this error */    
//  331 
//  332     /*!< Go to infinite loop */
//  333     while (1)
//  334     {
//  335     }
//  336   }  
//  337 }
//  338 #elif defined SYSCLK_FREQ_20MHz
//  339 /**
//  340   * @brief Sets System clock frequency to 20MHz and configure HCLK, PCLK2 
//  341   *        and PCLK1 prescalers.
//  342   * @param None.
//  343   * @arg None.
//  344   * @note : This function should be used only after reset.
//  345   * @retval value: None.
//  346   */
//  347 static void SetSysClockTo20(void)
//  348 {
//  349   __IO uint32_t StartUpCounter = 0, HSEStatus = 0;
//  350   
//  351   /*!< SYSCLK, HCLK, PCLK2 and PCLK1 configuration ---------------------------*/    
//  352   /*!< Enable HSE */    
//  353   RCC->CR |= ((uint32_t)RCC_CR_HSEON);
//  354  
//  355   /*!< Wait till HSE is ready and if Time out is reached exit */
//  356   do
//  357   {
//  358     HSEStatus = RCC->CR & RCC_CR_HSERDY;
//  359     StartUpCounter++;  
//  360   } while((HSEStatus == 0) && (StartUpCounter != HSEStartUp_TimeOut));
//  361 
//  362   if ((RCC->CR & RCC_CR_HSERDY) != RESET)
//  363   {
//  364     HSEStatus = (uint32_t)0x01;
//  365   }
//  366   else
//  367   {
//  368     HSEStatus = (uint32_t)0x00;
//  369   }  
//  370 
//  371   if (HSEStatus == (uint32_t)0x01)
//  372   {
//  373     /*!< Enable Prefetch Buffer */
//  374     FLASH->ACR |= FLASH_ACR_PRFTBE;
//  375 
//  376     /*!< Flash 0 wait state */
//  377     FLASH->ACR &= (uint32_t)((uint32_t)~FLASH_ACR_LATENCY);
//  378     FLASH->ACR |= (uint32_t)FLASH_ACR_LATENCY_0;    
//  379  
//  380     /*!< HCLK = SYSCLK */
//  381     RCC->CFGR |= (uint32_t)RCC_CFGR_HPRE_DIV1;
//  382       
//  383     /*!< PCLK2 = HCLK */
//  384     RCC->CFGR |= (uint32_t)RCC_CFGR_PPRE2_DIV1;
//  385     
//  386     /*!< PCLK1 = HCLK */
//  387     RCC->CFGR |= (uint32_t)RCC_CFGR_PPRE1_DIV1;
//  388     
//  389     /*!< PLLCLK = (8MHz / 2) * 5 = 20 MHz */
//  390     RCC->CFGR &= (uint32_t)((uint32_t)~(RCC_CFGR_PLLSRC | RCC_CFGR_PLLXTPRE | RCC_CFGR_PLLMULL));
//  391     RCC->CFGR |= (uint32_t)(RCC_CFGR_PLLSRC | RCC_CFGR_PLLXTPRE | RCC_CFGR_PLLMULL5);
//  392 
//  393     /*!< Enable PLL */
//  394     RCC->CR |= RCC_CR_PLLON;
//  395 
//  396     /*!< Wait till PLL is ready */
//  397     while((RCC->CR & RCC_CR_PLLRDY) == 0)
//  398     {
//  399     }
//  400 
//  401     /*!< Select PLL as system clock source */
//  402     RCC->CFGR &= (uint32_t)((uint32_t)~(RCC_CFGR_SW));
//  403     RCC->CFGR |= (uint32_t)RCC_CFGR_SW_PLL;    
//  404 
//  405     /*!< Wait till PLL is used as system clock source */
//  406     while ((RCC->CFGR & (uint32_t)RCC_CFGR_SWS) != (uint32_t)0x08)
//  407     {
//  408     }
//  409   }
//  410   else
//  411   { /*!< If HSE fails to start-up, the application will have wrong clock 
//  412          configuration. User can add here some code to deal with this error */    
//  413 
//  414     /*!< Go to infinite loop */
//  415     while (1)
//  416     {
//  417     }
//  418   } 
//  419 }
//  420 #elif defined SYSCLK_FREQ_36MHz
//  421 /**
//  422   * @brief Sets System clock frequency to 36MHz and configure HCLK, PCLK2 
//  423   *        and PCLK1 prescalers. 
//  424   * @param None.
//  425   * @arg None.
//  426   * @note : This function should be used only after reset.
//  427   * @retval value: None.
//  428   */
//  429 static void SetSysClockTo36(void)
//  430 {
//  431   __IO uint32_t StartUpCounter = 0, HSEStatus = 0;
//  432   
//  433   /*!< SYSCLK, HCLK, PCLK2 and PCLK1 configuration ---------------------------*/    
//  434   /*!< Enable HSE */    
//  435   RCC->CR |= ((uint32_t)RCC_CR_HSEON);
//  436  
//  437   /*!< Wait till HSE is ready and if Time out is reached exit */
//  438   do
//  439   {
//  440     HSEStatus = RCC->CR & RCC_CR_HSERDY;
//  441     StartUpCounter++;  
//  442   } while((HSEStatus == 0) && (StartUpCounter != HSEStartUp_TimeOut));
//  443 
//  444   if ((RCC->CR & RCC_CR_HSERDY) != RESET)
//  445   {
//  446     HSEStatus = (uint32_t)0x01;
//  447   }
//  448   else
//  449   {
//  450     HSEStatus = (uint32_t)0x00;
//  451   }  
//  452 
//  453   if (HSEStatus == (uint32_t)0x01)
//  454   {
//  455     /*!< Enable Prefetch Buffer */
//  456     FLASH->ACR |= FLASH_ACR_PRFTBE;
//  457 
//  458     /*!< Flash 1 wait state */
//  459     FLASH->ACR &= (uint32_t)((uint32_t)~FLASH_ACR_LATENCY);
//  460     FLASH->ACR |= (uint32_t)FLASH_ACR_LATENCY_1;    
//  461  
//  462     /*!< HCLK = SYSCLK */
//  463     RCC->CFGR |= (uint32_t)RCC_CFGR_HPRE_DIV1;
//  464       
//  465     /*!< PCLK2 = HCLK */
//  466     RCC->CFGR |= (uint32_t)RCC_CFGR_PPRE2_DIV1;
//  467     
//  468     /*!< PCLK1 = HCLK */
//  469     RCC->CFGR |= (uint32_t)RCC_CFGR_PPRE1_DIV1;
//  470     
//  471     /*!< PLLCLK = (8MHz / 2) * 9 = 36 MHz */
//  472     RCC->CFGR &= (uint32_t)((uint32_t)~(RCC_CFGR_PLLSRC | RCC_CFGR_PLLXTPRE | RCC_CFGR_PLLMULL));
//  473     RCC->CFGR |= (uint32_t)(RCC_CFGR_PLLSRC | RCC_CFGR_PLLXTPRE | RCC_CFGR_PLLMULL9);
//  474 
//  475     /*!< Enable PLL */
//  476     RCC->CR |= RCC_CR_PLLON;
//  477 
//  478     /*!< Wait till PLL is ready */
//  479     while((RCC->CR & RCC_CR_PLLRDY) == 0)
//  480     {
//  481     }
//  482 
//  483     /*!< Select PLL as system clock source */
//  484     RCC->CFGR &= (uint32_t)((uint32_t)~(RCC_CFGR_SW));
//  485     RCC->CFGR |= (uint32_t)RCC_CFGR_SW_PLL;    
//  486 
//  487     /*!< Wait till PLL is used as system clock source */
//  488     while ((RCC->CFGR & (uint32_t)RCC_CFGR_SWS) != (uint32_t)0x08)
//  489     {
//  490     }
//  491   }
//  492   else
//  493   { /*!< If HSE fails to start-up, the application will have wrong clock 
//  494          configuration. User can add here some code to deal with this error */    
//  495 
//  496     /*!< Go to infinite loop */
//  497     while (1)
//  498     {
//  499     }
//  500   } 
//  501 }
//  502 #elif defined SYSCLK_FREQ_48MHz
//  503 /**
//  504   * @brief Sets System clock frequency to 48MHz and configure HCLK, PCLK2 
//  505   *        and PCLK1 prescalers. 
//  506   * @param None.
//  507   * @arg None.
//  508   * @note : This function should be used only after reset.
//  509   * @retval value: None.
//  510   */
//  511 static void SetSysClockTo48(void)
//  512 {
//  513   __IO uint32_t StartUpCounter = 0, HSEStatus = 0;
//  514   
//  515   /*!< SYSCLK, HCLK, PCLK2 and PCLK1 configuration ---------------------------*/    
//  516   /*!< Enable HSE */    
//  517   RCC->CR |= ((uint32_t)RCC_CR_HSEON);
//  518  
//  519   /*!< Wait till HSE is ready and if Time out is reached exit */
//  520   do
//  521   {
//  522     HSEStatus = RCC->CR & RCC_CR_HSERDY;
//  523     StartUpCounter++;  
//  524   } while((HSEStatus == 0) && (StartUpCounter != HSEStartUp_TimeOut));
//  525 
//  526   if ((RCC->CR & RCC_CR_HSERDY) != RESET)
//  527   {
//  528     HSEStatus = (uint32_t)0x01;
//  529   }
//  530   else
//  531   {
//  532     HSEStatus = (uint32_t)0x00;
//  533   }  
//  534 
//  535   if (HSEStatus == (uint32_t)0x01)
//  536   {
//  537     /*!< Enable Prefetch Buffer */
//  538     FLASH->ACR |= FLASH_ACR_PRFTBE;
//  539 
//  540     /*!< Flash 1 wait state */
//  541     FLASH->ACR &= (uint32_t)((uint32_t)~FLASH_ACR_LATENCY);
//  542     FLASH->ACR |= (uint32_t)FLASH_ACR_LATENCY_1;    
//  543  
//  544     /*!< HCLK = SYSCLK */
//  545     RCC->CFGR |= (uint32_t)RCC_CFGR_HPRE_DIV1;
//  546       
//  547     /*!< PCLK2 = HCLK */
//  548     RCC->CFGR |= (uint32_t)RCC_CFGR_PPRE2_DIV1;
//  549     
//  550     /*!< PCLK1 = HCLK */
//  551     RCC->CFGR |= (uint32_t)RCC_CFGR_PPRE1_DIV2;
//  552     
//  553     /*!< PLLCLK = 8MHz * 6 = 48 MHz */
//  554     RCC->CFGR &= (uint32_t)((uint32_t)~(RCC_CFGR_PLLSRC | RCC_CFGR_PLLXTPRE | RCC_CFGR_PLLMULL));
//  555     RCC->CFGR |= (uint32_t)(RCC_CFGR_PLLSRC | RCC_CFGR_PLLMULL6);
//  556 
//  557     /*!< Enable PLL */
//  558     RCC->CR |= RCC_CR_PLLON;
//  559 
//  560     /*!< Wait till PLL is ready */
//  561     while((RCC->CR & RCC_CR_PLLRDY) == 0)
//  562     {
//  563     }
//  564 
//  565     /*!< Select PLL as system clock source */
//  566     RCC->CFGR &= (uint32_t)((uint32_t)~(RCC_CFGR_SW));
//  567     RCC->CFGR |= (uint32_t)RCC_CFGR_SW_PLL;    
//  568 
//  569     /*!< Wait till PLL is used as system clock source */
//  570     while ((RCC->CFGR & (uint32_t)RCC_CFGR_SWS) != (uint32_t)0x08)
//  571     {
//  572     }
//  573   }
//  574   else
//  575   { /*!< If HSE fails to start-up, the application will have wrong clock 
//  576          configuration. User can add here some code to deal with this error */    
//  577 
//  578     /*!< Go to infinite loop */
//  579     while (1)
//  580     {
//  581     }
//  582   } 
//  583 }
//  584 
//  585 #elif defined SYSCLK_FREQ_56MHz
//  586 /**
//  587   * @brief Sets System clock frequency to 56MHz and configure HCLK, PCLK2 
//  588   *        and PCLK1 prescalers. 
//  589   * @param None.
//  590   * @arg None.
//  591   * @note : This function should be used only after reset.
//  592   * @retval value: None.
//  593   */
//  594 static void SetSysClockTo56(void)
//  595 {
//  596   __IO uint32_t StartUpCounter = 0, HSEStatus = 0;
//  597   
//  598   /*!< SYSCLK, HCLK, PCLK2 and PCLK1 configuration ---------------------------*/   
//  599   /*!< Enable HSE */    
//  600   RCC->CR |= ((uint32_t)RCC_CR_HSEON);
//  601  
//  602   /*!< Wait till HSE is ready and if Time out is reached exit */
//  603   do
//  604   {
//  605     HSEStatus = RCC->CR & RCC_CR_HSERDY;
//  606     StartUpCounter++;  
//  607   } while((HSEStatus == 0) && (StartUpCounter != HSEStartUp_TimeOut));
//  608 
//  609   if ((RCC->CR & RCC_CR_HSERDY) != RESET)
//  610   {
//  611     HSEStatus = (uint32_t)0x01;
//  612   }
//  613   else
//  614   {
//  615     HSEStatus = (uint32_t)0x00;
//  616   }  
//  617 
//  618   if (HSEStatus == (uint32_t)0x01)
//  619   {
//  620     /*!< Enable Prefetch Buffer */
//  621     FLASH->ACR |= FLASH_ACR_PRFTBE;
//  622 
//  623     /*!< Flash 1 wait state */
//  624     FLASH->ACR &= (uint32_t)((uint32_t)~FLASH_ACR_LATENCY);
//  625     FLASH->ACR |= (uint32_t)FLASH_ACR_LATENCY_1;    
//  626  
//  627     /*!< HCLK = SYSCLK */
//  628     RCC->CFGR |= (uint32_t)RCC_CFGR_HPRE_DIV1;
//  629       
//  630     /*!< PCLK2 = HCLK */
//  631     RCC->CFGR |= (uint32_t)RCC_CFGR_PPRE2_DIV1;
//  632     
//  633     /*!< PCLK1 = HCLK */
//  634     RCC->CFGR |= (uint32_t)RCC_CFGR_PPRE1_DIV2;
//  635     
//  636     /*!< PLLCLK = 8MHz * 7 = 56 MHz */
//  637     RCC->CFGR &= (uint32_t)((uint32_t)~(RCC_CFGR_PLLSRC | RCC_CFGR_PLLXTPRE | RCC_CFGR_PLLMULL));
//  638     RCC->CFGR |= (uint32_t)(RCC_CFGR_PLLSRC | RCC_CFGR_PLLMULL7);
//  639 
//  640     /*!< Enable PLL */
//  641     RCC->CR |= RCC_CR_PLLON;
//  642 
//  643     /*!< Wait till PLL is ready */
//  644     while((RCC->CR & RCC_CR_PLLRDY) == 0)
//  645     {
//  646     }
//  647 
//  648     /*!< Select PLL as system clock source */
//  649     RCC->CFGR &= (uint32_t)((uint32_t)~(RCC_CFGR_SW));
//  650     RCC->CFGR |= (uint32_t)RCC_CFGR_SW_PLL;    
//  651 
//  652     /*!< Wait till PLL is used as system clock source */
//  653     while ((RCC->CFGR & (uint32_t)RCC_CFGR_SWS) != (uint32_t)0x08)
//  654     {
//  655     }
//  656   }
//  657   else
//  658   { /*!< If HSE fails to start-up, the application will have wrong clock 
//  659          configuration. User can add here some code to deal with this error */    
//  660 
//  661     /*!< Go to infinite loop */
//  662     while (1)
//  663     {
//  664     }
//  665   } 
//  666 }
//  667 
//  668 #elif defined SYSCLK_FREQ_72MHz
//  669 /**
//  670   * @brief Sets System clock frequency to 72MHz and configure HCLK, PCLK2 
//  671   *        and PCLK1 prescalers. 
//  672   * @param None.
//  673   * @arg None.
//  674   * @note : This function should be used only after reset.
//  675   * @retval value: None.
//  676   */
//  677 static void SetSysClockTo72(void)
//  678 {
//  679   __IO uint32_t StartUpCounter = 0, HSEStatus = 0;
//  680   
//  681   /*!< SYSCLK, HCLK, PCLK2 and PCLK1 configuration ---------------------------*/    
//  682   /*!< Enable HSE */    
//  683   RCC->CR |= ((uint32_t)RCC_CR_HSEON);
//  684  
//  685   /*!< Wait till HSE is ready and if Time out is reached exit */
//  686   do
//  687   {
//  688     HSEStatus = RCC->CR & RCC_CR_HSERDY;
//  689     StartUpCounter++;  
//  690   } while((HSEStatus == 0) && (StartUpCounter != HSEStartUp_TimeOut));
//  691 
//  692   if ((RCC->CR & RCC_CR_HSERDY) != RESET)
//  693   {
//  694     HSEStatus = (uint32_t)0x01;
//  695   }
//  696   else
//  697   {
//  698     HSEStatus = (uint32_t)0x00;
//  699   }  
//  700 
//  701   if (HSEStatus == (uint32_t)0x01)
//  702   {
//  703     /*!< Enable Prefetch Buffer */
//  704     FLASH->ACR |= FLASH_ACR_PRFTBE;
//  705 
//  706     /*!< Flash 2 wait state */
//  707     FLASH->ACR &= (uint32_t)((uint32_t)~FLASH_ACR_LATENCY);
//  708     FLASH->ACR |= (uint32_t)FLASH_ACR_LATENCY_2;    
//  709  
//  710     /*!< HCLK = SYSCLK */
//  711     RCC->CFGR |= (uint32_t)RCC_CFGR_HPRE_DIV1;
//  712       
//  713     /*!< PCLK2 = HCLK */
//  714     RCC->CFGR |= (uint32_t)RCC_CFGR_PPRE2_DIV1;
//  715     
//  716     /*!< PCLK1 = HCLK */
//  717     RCC->CFGR |= (uint32_t)RCC_CFGR_PPRE1_DIV2;
//  718     
//  719     /*!< PLLCLK = 8MHz * 9 = 72 MHz */
//  720     RCC->CFGR &= (uint32_t)((uint32_t)~(RCC_CFGR_PLLSRC | RCC_CFGR_PLLXTPRE | RCC_CFGR_PLLMULL));
//  721     RCC->CFGR |= (uint32_t)(RCC_CFGR_PLLSRC | RCC_CFGR_PLLMULL9);
//  722 
//  723     /*!< Enable PLL */
//  724     RCC->CR |= RCC_CR_PLLON;
//  725 
//  726     /*!< Wait till PLL is ready */
//  727     while((RCC->CR & RCC_CR_PLLRDY) == 0)
//  728     {
//  729     }
//  730 
//  731     /*!< Select PLL as system clock source */
//  732     RCC->CFGR &= (uint32_t)((uint32_t)~(RCC_CFGR_SW));
//  733     RCC->CFGR |= (uint32_t)RCC_CFGR_SW_PLL;    
//  734 
//  735     /*!< Wait till PLL is used as system clock source */
//  736     while ((RCC->CFGR & (uint32_t)RCC_CFGR_SWS) != (uint32_t)0x08)
//  737     {
//  738     }
//  739   }
//  740   else
//  741   { /*!< If HSE fails to start-up, the application will have wrong clock 
//  742          configuration. User can add here some code to deal with this error */    
//  743 
//  744     /*!< Go to infinite loop */
//  745     while (1)
//  746     {
//  747     }
//  748   }
//  749 }
//  750 #endif
//  751 
//  752 /**
//  753   * @}
//  754   */
//  755   
//  756 /******************* (C) COPYRIGHT 2009 STMicroelectronics *****END OF FILE****/
// 
//  20 bytes in section .rodata
// 228 bytes in section .text
// 
// 228 bytes of CODE  memory
//  20 bytes of CONST memory
//
//Errors: none
//Warnings: none
